package ext {
import ext.util.HashMap;

[Uses("ext.Base")]
[Deprecated]
[Native("Ext.AbstractManager", require)]
[ExcludeClass]
/**
 * Base Manager class
 */
public class AbstractManager extends ext.Base {
  /**
   * Contains all of the items currently managed
   */
  public native function get all():ext.util.HashMap;

  /**
   * @private
   */
  public native function set all(value:ext.util.HashMap):void;

  /**
   * Creates and returns an instance of whatever this manager manages, based on the supplied type and
   * config object.
   * @param config The config object
   * @param defaultType If no type is discovered in the config object, we fall back to this type
   * @return The instance of whatever this manager is managing
   */
  public native function create(config:Object, defaultType:String):*;

  /**
   * Executes the specified function once for each item in the collection.
   * @param fn The function to execute.
   * @param {String} fn.key The key of the item
   * @param {Number} fn.value The value of the item
   * @param {Number} fn.length The total number of items in the collection
   * @param {Boolean} fn.return False to cease iteration.
   * @param scope The scope to execute in. Defaults to <code>this</code>.
   */
  public native function each(fn:Function, scope:Object):void;

  /**
   * Returns an item by id.
   * For additional details see <a href="#!/api/Ext.util.HashMap-method-get" rel="Ext.util.HashMap-method-get" class="docClass">Ext.util.HashMap.get</a>.
   * @param id The id of the item
   * @return The item, undefined if not found.
   */
  public native function get(id:String):Object;

  /**
   * Gets the number of items in the collection.
   * @return The number of items in the collection.
   */
  public native function getCount():Number;

  /**
   * Checks if an item type is registered.
   * @param type The mnemonic string by which the class may be looked up
   * @return Whether the type is registered.
   */
  public native function isRegistered(type:String):Boolean;

  /**
   * Registers a function that will be called when an item with the specified id is added to the manager.
   * This will happen on instantiation.
   * @param id The item id
   * @param fn The callback function. Called with a single parameter, the item.
   * @param scope The scope (this reference) in which the callback is executed.
   * Defaults to the item.
   */
  public native function onAvailable(id:String, fn:Function, scope:Object):void;

  /**
   * Registers an item to be managed
   * @param item The item to register
   */
  public native function register(item:*):void;

  /**
   * Registers a new item constructor, keyed by a type key.
   * @param type The mnemonic string by which the class may be looked up.
   * @param cls The new instance class.
   */
  public native function registerType(type:String, cls:Class):void;

  /**
   * Unregisters an item by removing it from this manager
   * @param item The item to unregister
   */
  public native function unregister(item:*):void;
}
}