package ext {

[Uses("ext.SAjax")]
[Uses("ext.data.Connection")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Native("Ext.Ajax", require)]
/**
 * A singleton instance of an <code><a href="#!/api/Ext.data.Connection" rel="Ext.data.Connection" class="docClass">Ext.data.Connection</a></code>. This class is used to
 * communicate with your server side code. It can be used as follows:
 *
 * <pre><code> <a href="#!/api/Ext.Ajax-method-request" rel="Ext.Ajax-method-request" class="docClass">Ext.Ajax.request</a>({
 *      url: 'ajax_demo/sample.json',
 *
 *      success: function(response, opts) {
 *          var obj = <a href="#!/api/Ext-method-decode" rel="Ext-method-decode" class="docClass">Ext.decode</a>(response.responseText);
 *          console.dir(obj);
 *      },
 *
 *      failure: function(response, opts) {
 *          console.log('server-side failure with status code ' + response.status);
 *      }
 *  });
 * </code></pre>
 *
 * <p>Default options for all requests can be set by changing a property on the <a href="#!/api/Ext.Ajax" rel="Ext.Ajax" class="docClass">Ext.Ajax</a> class:</p>
 *
 * <pre><code> <a href="#!/api/Ext.Ajax-method-setTimeout" rel="Ext.Ajax-method-setTimeout" class="docClass">Ext.Ajax.setTimeout</a>(60000); // 60 seconds
 * </code></pre>
 *
 * <p>Any options specified in the request method for the Ajax request will override any
 * defaults set on the <code><a href="#!/api/Ext.Ajax" rel="Ext.Ajax" class="docClass">Ext.Ajax</a></code> singleton. In the code sample below, the timeout for the
 * request will be 60 seconds.</p>
 *
 * <pre><code> <a href="#!/api/Ext.Ajax-method-setTimeout" rel="Ext.Ajax-method-setTimeout" class="docClass">Ext.Ajax.setTimeout</a>(120000); // 120 seconds
 *
 *  <a href="#!/api/Ext.Ajax-method-request" rel="Ext.Ajax-method-request" class="docClass">Ext.Ajax.request</a>({
 *      url: 'page.aspx',
 *      timeout: 60000
 *  });
 * </code></pre>
 *
 * <p>In general, this class will be used for all Ajax requests in your application. The main
 * reason for creating a separate <code><a href="#!/api/Ext.data.Connection" rel="Ext.data.Connection" class="docClass">Ext.data.Connection</a></code> is for a series of
 * requests that share common settings that are different to all other requests in the
 * application.</p>
 */
public const Ajax:ext.SAjax;
}