package ext {

[Uses("ext.SComponentManager")]
[Uses("ext.Base")]
[Native("Ext.ComponentManager", require)]
/**
 * Provides a registry of all Components (instances of <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Ext.Component</a> or any subclass
 * thereof) on a page so that they can be easily accessed by <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">component</a>
 * <a href="#!/api/Ext.Component-cfg-id" rel="Ext.Component-cfg-id" class="docClass">id</a> (see <a href="#!/api/Ext.ComponentManager-method-get" rel="Ext.ComponentManager-method-get" class="docClass">get</a>, or the convenience method
 * <a href="#!/api/Ext-method-getCmp" rel="Ext-method-getCmp" class="docClass">Ext.getCmp</a>).
 *
 * <p>This object also provides a registry of available Component <em>classes</em> indexed by a
 * mnemonic code known as the Component's <a href="#!/api/Ext.Component-cfg-xtype" rel="Ext.Component-cfg-xtype" class="docClass">xtype</a>. The <code>xtype</code>
 * provides a way to avoid instantiating child Components when creating a full, nested
 * config object for a complete Ext page.</p>
 *
 * <p>A child Component may be specified simply as a <em>config object</em> as long as the correct
 * <code><a href="#!/api/Ext.Component-cfg-xtype" rel="Ext.Component-cfg-xtype" class="docClass">xtype</a></code> is specified so that if and when the Component
 * needs rendering, the correct type can be looked up for lazy instantiation.</p>
 */
public const ComponentManager:ext.SComponentManager;
}