package ext {

[Uses("ext.SExt")]
[Native("Ext", require)]
/**
 * The Ext namespace (global object) encapsulates all classes, singletons, and
 * utility methods provided by Sencha's libraries.
 *
 * <p>Most user interface Components are at a lower level of nesting in the namespace,
 * but many common utility functions are provided as direct properties of the Ext namespace.</p>
 *
 * <p>Also many frequently used methods from other classes are provided as shortcuts
 * within the Ext namespace. For example <a href="#!/api/Ext-method-getCmp" rel="Ext-method-getCmp" class="docClass">Ext.getCmp</a> aliases
 * <a href="#!/api/Ext.ComponentManager-method-get" rel="Ext.ComponentManager-method-get" class="docClass">Ext.ComponentManager.get</a>.</p>
 *
 * <p>Many applications are initiated with Ext.application which is
 * called once the DOM is ready. This ensures all scripts have been loaded, preventing
 * dependency issues. For example:</p>
 *
 * <pre><code> Ext.application({
 *      name: 'MyApp',
 *
 *      launch: function () {
 *          <a href="#!/api/Ext.MessageBox-method-alert" rel="Ext.MessageBox-method-alert" class="docClass">Ext.Msg.alert</a>(this.name, 'Ready to go!');
 *      }
 *  });
 * </code></pre>
 *
 * <p><b><a href="http://www.sencha.com/products/sencha-cmd/">Sencha Cmd</a></b> is a free tool
 * for helping you generate and build Ext JS (and Sencha Touch) applications. See
 * <code><a href="#!/api/Ext.app.Application" rel="Ext.app.Application" class="docClass">Application</a></code> for more information about creating an app.</p>
 *
 * <p>A lower-level technique that does not use the <code><a href="#!/api/Ext.app.Application" rel="Ext.app.Application" class="docClass">Ext.app.Application</a></code> architecture is
 * <a href="#!/api/Ext-method-onReady" rel="Ext-method-onReady" class="docClass">Ext.onReady</a>.</p>
 *
 * <p>For more information about how to use the Ext classes, see:</p>
 *
 * <ul>
 * <li><a href="http://www.sencha.com/learn/">The Learning Center</a></li>
 * <li><a href="http://www.sencha.com/learn/Ext_FAQ">The FAQ</a></li>
 * <li><a href="http://www.sencha.com/forum/">The forums</a></li>
 * </ul>
 */
public const Ext:ext.SExt;
}