package ext {

[Uses("ext.SGlobalEvents")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Native("Ext.GlobalEvents", require)]
/**
 * An <code><a href="#!/api/Ext.mixin.Observable" rel="Ext.mixin.Observable" class="docClass">Observable</a></code> through which Ext fires global events.
 *
 * <p><a href="#!/api/Ext-method-on" rel="Ext-method-on" class="docClass">Ext.on</a>() and <a href="#!/api/Ext-method-un" rel="Ext-method-un" class="docClass">Ext.un</a>() are shorthand for <a href="#!/api/Ext.GlobalEvents-method-addListener" rel="Ext.GlobalEvents-method-addListener" class="docClass">addListener</a> and <a href="#!/api/Ext.GlobalEvents-method-removeListener" rel="Ext.GlobalEvents-method-removeListener" class="docClass">removeListener</a>
 * on this Observable.  For example, to listen for the idle event:</p>
 *
 * <pre><code><a href="#!/api/Ext-method-on" rel="Ext-method-on" class="docClass">Ext.on</a>('idle', function() {
 *     // do something
 * });
 * </code></pre>
 */
public const GlobalEvents:ext.SGlobalEvents;
}