package ext {

[Uses("ext.Base")]
[Native("Ext.ProgressBase", require)]
[ExcludeClass]
public class ProgressBase extends ext.Base implements ext.IProgressBase {
  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * A template used to create this ProgressBar's background text given two values:
   *
   * <p>   `value  ' - The raw progress value between 0 and 1
   *    'percent' - The value as a percentage between 0 and 100</p>
   * @see #getTextTpl()
   * @see #setTextTpl()
   */
  public native function get textTpl():*;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set textTpl(value:*):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * A floating point value between 0 and 1 (e.g., .5)
   * @default 0
   * @see #getValue()
   * @see #setValue()
   */
  public native function get value():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set value(value:Number):void;

  /**
   * Returns the value of <a href="#!/api/Ext.ProgressBase-cfg-textTpl" rel="Ext.ProgressBase-cfg-textTpl" class="docClass">textTpl</a>.
   */
  public native function getTextTpl():*;

  /**
   * Returns the value of <a href="#!/api/Ext.ProgressBase-cfg-value" rel="Ext.ProgressBase-cfg-value" class="docClass">value</a>.
   */
  public native function getValue():Number;

  /**
   * Sets the value of <a href="#!/api/Ext.ProgressBase-cfg-textTpl" rel="Ext.ProgressBase-cfg-textTpl" class="docClass">textTpl</a>.
   * @param textTpl The new value.
   */
  public native function setTextTpl(textTpl:*):void;

  /**
   * Sets the value of <a href="#!/api/Ext.ProgressBase-cfg-value" rel="Ext.ProgressBase-cfg-value" class="docClass">value</a>.
   * @param value The new value.
   */
  public native function setValue(value:Number):void;
}
}