package ext {

[Native]
/**
 * A simple class to verify if a browser feature exists or not on the current device.
 *
 * <pre><code>if (Ext.feature.has.Canvas) {
 *     // do some cool things with canvas here
 * }
 * </code></pre>
 *
 * <p>See the <a href="#!/api/Ext.feature-method-has" rel="Ext.feature-method-has" class="docClass">has</a> property/method for details of the features that can be detected.</p>
 * <p>Type of singleton feature.</p>
 * @see ext.#feature ext.feature
 */
public class Sfeature {
  /**
   * Verifies if a browser feature exists or not on the current device.
   *
   * <p>A "hybrid" property, can be either accessed as a method call, i.e:</p>
   *
   * <pre><code>if (<a href="#!/api/Ext.feature-method-has" rel="Ext.feature-method-has" class="docClass">Ext.feature.has</a>('Canvas')) {
   *     // ...
   * }
   * </code></pre>
   *
   * <p>or as an object with boolean properties, i.e:</p>
   *
   * <pre><code>if (Ext.feature.has.Canvas) {
   *     // ...
   * }
   * </code></pre>
   *
   * <p>For possible properties/parameter values see <code><a href="#!/api/Ext.supports" rel="Ext.supports" class="docClass">Ext.supports</a></code>.</p>
   * @param name The feature name to check.
   */
  public native function has(name:String):Boolean;
}
}