package ext.container.events {
import ext.Component;
import ext.container.Container;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class Container_component_indexEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires after any <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Ext.Component</a> is added or inserted into the container.
   * @since 2.3.0
   * @see ext.container.Container
   * @eventType onAdd
   */
  public static const ADD:String = "onAdd";

  /**
   * "Fires before any <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Ext.Component</a> is added or inserted into the container.
   * A handler can return false to cancel the add.
   * @since 2.3.0
   * @see ext.container.Container
   * @eventType onBeforeAdd
   */
  public static const BEFORE_ADD:String = "onBeforeAdd";

  public function Container_component_indexEvent(type:String, arguments:Array) {
    super(null, null);
  }

  public native function get source():ext.container.Container;

  /**
   * The component that was added
   */
  public native function get component():ext.Component;

  /**
   * The index at which the component was added to the container's items collection
   */
  public native function get index():Number;
}
}