package ext.data {

[Uses("ext.data.Store")]
[Uses("ext.data.LocalStore")]
[Uses("ext.Mixin")]
[Uses("ext.Base")]
[Uses("ext.data.ProxyStore")]
[Uses("ext.data.AbstractStore")]
[Uses("ext.mixin.Observable")]
[Uses("ext.mixin.Factoryable")]
[Native("Ext.data.ArrayStore", require)]
/**
 * Small helper class to make creating <a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a>s from Array data easier. An ArrayStore will be
 * automatically configured with a <a href="#!/api/Ext.data.reader.Array" rel="Ext.data.reader.Array" class="docClass">Ext.data.reader.Array</a>.
 *
 * <p>A store configuration would be something like:</p>
 *
 * <pre><code>var store = <a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.data.ArrayStore" rel="Ext.data.ArrayStore" class="docClass">Ext.data.ArrayStore</a>', {
 *     // store configs
 *     storeId: 'myStore',
 *     // reader configs
 *     fields: [
 *        'company',
 *        {name: 'price', type: 'float'},
 *        {name: 'change', type: 'float'},
 *        {name: 'pctChange', type: 'float'},
 *        {name: 'lastChange', type: 'date', dateFormat: 'n/j h:ia'}
 *     ]
 * });
 * </code></pre>
 *
 * <p>This store is configured to consume a returned object of the form:</p>
 *
 * <pre><code>var myData = [
 *     ['3m Co',71.72,0.02,0.03,'9/1 12:00am'],
 *     ['Alcoa Inc',29.01,0.42,1.47,'9/1 12:00am'],
 *     ['Boeing Co.',75.43,0.53,0.71,'9/1 12:00am'],
 *     ['Hewlett-Packard Co.',36.53,-0.03,-0.08,'9/1 12:00am'],
 *     ['Wal-Mart Stores, Inc.',45.45,0.73,1.63,'9/1 12:00am']
 * ];
 * </code></pre>
 *
 * <p>An object literal of this form could also be used as the <a href="#!/api/Ext.data.ArrayStore-cfg-data" rel="Ext.data.ArrayStore-cfg-data" class="docClass">data</a> config option.</p>
 */
public class ArrayStore extends ext.data.Store {
  /**
   * @param config @inheritDoc
   */
  public function ArrayStore(config:ext.data.ArrayStore = null) {
    super();
  }
}
}