package ext.data {
import ext.Base;

[Uses("ext.Base")]
[Deprecated(replacement = "ext.data.Model", since = "5.0")]
[Native("Ext.data.Error", require)]
/**
 * This class hols the results of a validator for an <code><a href="#!/api/Ext.data.Model" rel="Ext.data.Model" class="docClass">Ext.data.Model</a></code>. These objects are
 * placed in an <code><a href="#!/api/Ext.data.ErrorCollection" rel="Ext.data.ErrorCollection" class="docClass">Ext.data.ErrorCollection</a></code> and returned by <code><a href="#!/api/Ext.data.Model-method-validate" rel="Ext.data.Model-method-validate" class="docClass">Ext.data.Model.validate</a></code>.
 *
 * <p>Usually this class does not need to be instantiated directly - instances are instead created
 * automatically when <a href="#!/api/Ext.data.Model-method-validate" rel="Ext.data.Model-method-validate" class="docClass">validate</a> on a model instance.</p>
 */
public class DataError extends ext.Base {
  /**
   * @param config @inheritDoc
   */
  public function DataError(config:ext.data.DataError = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The name of the field this error belongs to.
   * @see #getField()
   * @see #setField()
   */
  public native function get field():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set field(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The message containing the description of the error.
   * @default ''
   * @see #getMessage()
   * @see #setMessage()
   */
  public native function get message():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set message(value:String):void;

  /**
   * Returns the value of <a href="#!/api/Ext.data.Error-cfg-field" rel="Ext.data.Error-cfg-field" class="docClass">field</a>.
   */
  public native function getField():String;

  /**
   * Returns the value of <a href="#!/api/Ext.data.Error-cfg-message" rel="Ext.data.Error-cfg-message" class="docClass">message</a>.
   */
  public native function getMessage():String;

  /**
   * Sets the value of <a href="#!/api/Ext.data.Error-cfg-field" rel="Ext.data.Error-cfg-field" class="docClass">field</a>.
   * @param field The new value.
   */
  public native function setField(field:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.data.Error-cfg-message" rel="Ext.data.Error-cfg-message" class="docClass">message</a>.
   * @param message The new value.
   */
  public native function setMessage(message:String):void;
}
}