package ext.data {

[Uses("ext.data.Store")]
[Uses("ext.data.LocalStore")]
[Uses("ext.Mixin")]
[Uses("ext.Base")]
[Uses("ext.data.ProxyStore")]
[Uses("ext.data.AbstractStore")]
[Uses("ext.mixin.Observable")]
[Uses("ext.mixin.Factoryable")]
[Native("Ext.data.DirectStore", require)]
/**
 * Small helper class to create an <a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a> configured with an <a href="#!/api/Ext.data.proxy.Direct" rel="Ext.data.proxy.Direct" class="docClass">Ext.data.proxy.Direct</a>
 * and <a href="#!/api/Ext.data.reader.Json" rel="Ext.data.reader.Json" class="docClass">Ext.data.reader.Json</a> to make interacting with an <a href="#!/api/Ext.direct.Manager" rel="Ext.direct.Manager" class="docClass">Ext.direct.Manager</a> server-side
 * <a href="#!/api/Ext.direct.Provider" rel="Ext.direct.Provider" class="docClass">Provider</a> easier. To create a different proxy/reader combination create a basic
 * <a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a> configured as needed.
 *
 * <p><strong>Note:</strong> Although they are not listed, this class inherits all of the config options of:</p>
 *
 * <ul>
 * <li><p><strong><a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Store</a></strong></p></li>
 * <li><p><strong><a href="#!/api/Ext.data.reader.Json" rel="Ext.data.reader.Json" class="docClass">JsonReader</a></strong></p>
 *
 * <ul>
 * <li><strong><a href="#!/api/Ext.data.reader.Json-cfg-rootProperty" rel="Ext.data.reader.Json-cfg-rootProperty" class="docClass">rootProperty</a></strong></li>
 * <li><strong><a href="#!/api/Ext.data.reader.Json-cfg-totalProperty" rel="Ext.data.reader.Json-cfg-totalProperty" class="docClass">totalProperty</a></strong></li>
 * </ul>
 * </li>
 * <li><p><strong><a href="#!/api/Ext.data.proxy.Direct" rel="Ext.data.proxy.Direct" class="docClass">DirectProxy</a></strong></p>
 *
 * <ul>
 * <li><strong><a href="#!/api/Ext.data.proxy.Direct-cfg-directFn" rel="Ext.data.proxy.Direct-cfg-directFn" class="docClass">directFn</a></strong></li>
 * <li><strong><a href="#!/api/Ext.data.proxy.Direct-cfg-paramOrder" rel="Ext.data.proxy.Direct-cfg-paramOrder" class="docClass">paramOrder</a></strong></li>
 * <li><strong><a href="#!/api/Ext.data.proxy.Direct-cfg-paramsAsHash" rel="Ext.data.proxy.Direct-cfg-paramsAsHash" class="docClass">paramsAsHash</a></strong></li>
 * </ul>
 * </li>
 * </ul>
 */
public class DirectStore extends ext.data.Store {
  /**
   * @param config @inheritDoc
   */
  public function DirectStore(config:ext.data.DirectStore = null) {
    super();
  }
}
}