package ext.data {
import ext.Base;

[Uses("ext.Base")]
[Deprecated(replacement = "ext.data.field.DataField")]
[Native]
/**
 * <p>Type of singleton Types.</p>
 * @see ext.data.#Types ext.data.Types
 */
public class STypes extends ext.Base {
  /**
   * This data type means that no conversion is applied to the raw data before it is placed into a Record.
   */
  public native function get AUTO():Object;

  /**
   * This data type means that the raw data is converted into a boolean before it is placed into
   * a Record. The string "true" and the number 1 are converted to boolean true.
   *
   * <p>The synonym <code>BOOLEAN</code> is equivalent.</p>
   */
  public native function get BOOL():Object;

  /**
   * This data type means that the raw data is converted into a boolean before it is placed into
   * a Record. The string "true" and the number 1 are converted to boolean <code>true</code>.
   *
   * <p>The synonym <code>BOOL</code> is equivalent.</p>
   */
  public native function get BOOLEAN():Object;

  /**
   * This data type means that the raw data is converted into a Date before it is placed into a Record.
   * The date format is specified in the constructor of the <a href="#!/api/Ext.data.field.Field" rel="Ext.data.field.Field" class="docClass">Ext.data.Field</a> to which this type is
   * being applied.
   */
  public native function get DATE():Object;

  /**
   * This data type means that the raw data is converted into a number before it is placed into a Record.
   *
   * <p>The synonym <code>NUMBER</code> is equivalent.</p>
   */
  public native function get FLOAT():Object;

  /**
   * This data type means that the raw data is converted into an integer before it is placed into a Record.
   *
   * <p>The synonym <code>INTEGER</code> is equivalent.</p>
   */
  public native function get INT():Object;

  /**
   * This data type means that the raw data is converted into an integer before it is placed into a Record.
   *
   * <p>The synonym <code>INT</code> is equivalent.</p>
   */
  public native function get INTEGER():Object;

  /**
   * This data type means that the raw data is converted into a number before it is placed into a Record.
   *
   * <p>The synonym <code>FLOAT</code> is equivalent.</p>
   */
  public native function get NUMBER():Object;

  /**
   * This data type means that the raw data is converted into a String before it is placed into a Record.
   */
  public native function get STRING():Object;

  /**
   * A regular expression for stripping non-numeric characters from a numeric value.
   * This should be overridden for localization.
   * @default /[\$,%]/g
   */
  public native function get stripRe():RegExp;

  /**
   * @private
   */
  public native function set stripRe(value:RegExp):void;
}
}