package ext.data.events {
import ext.data.Store;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class AbstractStore_store_sortersEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires before a store is sorted.
   *
   * <p>For <a href="#!/api/Ext.data.AbstractStore-cfg-remoteSort" rel="Ext.data.AbstractStore-cfg-remoteSort" class="docClass">remotely sorted</a> stores, this will be just before the load operation triggered by changing the
   * store's sorters.</p>
   *
   * <p>For locally sorted stores, this will be just before the data items in the store's backing collection are sorted.</p>
   * @see ext.data.AbstractStore
   * @eventType onBeforeSort
   */
  public static const BEFORE_SORT:String = "onBeforeSort";

  public function AbstractStore_store_sortersEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The store being sorted
   */
  public native function get store():ext.data.Store;

  /**
   * Array of sorters applied to the store
   */
  public native function get sorters():Array;
}
}