package ext.data.events {
import ext.data.Connection;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class Connection_response_optionsEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires if the request was successfully completed.
   * @see ext.data.Connection
   * @eventType onRequestComplete
   */
  public static const REQUEST_COMPLETE:String = "onRequestComplete";

  /**
   * "Fires if an error HTTP status was returned from the server. This event may also
   * be listened to in the event that a request has timed out or has been aborted.
   * See <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html">HTTP Status Code Definitions</a>
   * for details of HTTP status codes.
   * @see ext.data.Connection
   * @eventType onRequestException
   */
  public static const REQUEST_EXCEPTION:String = "onRequestException";

  public function Connection_response_optionsEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * This Connection object.
   */
  public native function get conn():ext.data.Connection;

  /**
   * The XHR object containing the response data.
   * See <a href="http://www.w3.org/TR/XMLHttpRequest/">The XMLHttpRequest Object</a> for details.
   */
  public native function get response():Object;

  /**
   * The options config object passed to the <a href="#!/api/Ext.data.Connection-method-request" rel="Ext.data.Connection-method-request" class="docClass">request</a> method.
   */
  public native function get options():Object;
}
}