package ext.data.request {
import ext.Base;
import ext.mixin.IFactoryable;

[Uses("ext.Base")]
[Uses("ext.mixin.Factoryable")]
[Native("Ext.data.request.Base", require)]
/**
 * This class manages a pending Ajax request. Instances of this type are created by the
 * <code><a href="#!/api/Ext.data.Connection-method-request" rel="Ext.data.Connection-method-request" class="docClass">Ext.data.Connection.request</a></code> method.
 */
public class BaseRequest extends ext.Base implements ext.mixin.IFactoryable {
  /**
   * @inheritDoc
   */
  public native function get factoryConfig():Object;

  /**
   * @inheritDoc
   */
  public native function set factoryConfig(value:Object):void;

  /**
   * Determines whether this request is in progress.
   * @return <code>true</code> if this request is in progress, <code>false</code> if complete.
   */
  public native function isLoading():Boolean;

  /**
   * Start the request.
   */
  public native function start():void;
}
}