package ext.data.validator {

[Uses("ext.data.validator.Validator")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.data.validator.Format", require)]
/**
 * Validates that the passed value matches a specific format specified by a regex.
 * The format is provided by the <a href="#!/api/Ext.data.validator.Format-cfg-matcher" rel="Ext.data.validator.Format-cfg-matcher" class="docClass">matcher</a> config.
 */
public class FormatValidator extends ext.data.validator.Validator {
  /**
   * @param config @inheritDoc
   */
  public function FormatValidator(config:ext.data.validator.FormatValidator = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The matcher regex to test against the value.
   * @see #getMatcher()
   * @see #setMatcher()
   */
  public native function get matcher():RegExp;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set matcher(value:RegExp):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The error message to return when the value does not match the format.
   * @default 'Is in the wrong format'
   * @see #getMessage()
   * @see #setMessage()
   */
  public native function get message():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set message(value:String):void;

  /**
   * Returns the value of <a href="#!/api/Ext.data.validator.Format-cfg-matcher" rel="Ext.data.validator.Format-cfg-matcher" class="docClass">matcher</a>.
   */
  public native function getMatcher():RegExp;

  /**
   * Returns the value of <a href="#!/api/Ext.data.validator.Format-cfg-message" rel="Ext.data.validator.Format-cfg-message" class="docClass">message</a>.
   */
  public native function getMessage():String;

  /**
   * Sets the value of <a href="#!/api/Ext.data.validator.Format-cfg-matcher" rel="Ext.data.validator.Format-cfg-matcher" class="docClass">matcher</a>.
   * @param matcher The new value.
   */
  public native function setMatcher(matcher:RegExp):void;

  /**
   * Sets the value of <a href="#!/api/Ext.data.validator.Format-cfg-message" rel="Ext.data.validator.Format-cfg-message" class="docClass">message</a>.
   * @param message The new value.
   */
  public native function setMessage(message:String):void;
}
}