package ext.data.validator {

[Uses("ext.data.validator.ListValidator")]
[Uses("ext.data.validator.Validator")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.data.validator.Inclusion", require)]
/**
 * Validates that the value exists in a <a href="#!/api/Ext.data.validator.Inclusion-cfg-list" rel="Ext.data.validator.Inclusion-cfg-list" class="docClass">list</a> of values.
 */
public class InclusionValidator extends ext.data.validator.ListValidator {
  /**
   * @param config @inheritDoc
   */
  public function InclusionValidator(config:ext.data.validator.InclusionValidator = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The error message to return when the passed value does not exist
   * in the specified <a href="#!/api/Ext.data.validator.Inclusion-cfg-list" rel="Ext.data.validator.Inclusion-cfg-list" class="docClass">list</a>.
   * @default 'Is not in the list of acceptable values'
   * @see #getMessage()
   * @see #setMessage()
   */
  public native function get message():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set message(value:String):void;

  /**
   * Returns the value of <a href="#!/api/Ext.data.validator.Inclusion-cfg-message" rel="Ext.data.validator.Inclusion-cfg-message" class="docClass">message</a>.
   */
  public native function getMessage():String;

  /**
   * Sets the value of <a href="#!/api/Ext.data.validator.Inclusion-cfg-message" rel="Ext.data.validator.Inclusion-cfg-message" class="docClass">message</a>.
   * @param message The new value.
   */
  public native function setMessage(message:String):void;
}
}