package ext.data.validator {

[Uses("ext.data.validator.BoundValidator")]
[Uses("ext.data.validator.Validator")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.data.validator.Length", require)]
/**
 * Validates that the length of the value is between a <a href="#!/api/Ext.data.validator.Length-cfg-min" rel="Ext.data.validator.Length-cfg-min" class="docClass">min</a> and <a href="#!/api/Ext.data.validator.Length-cfg-max" rel="Ext.data.validator.Length-cfg-max" class="docClass">max</a>.
 */
public class LengthValidator extends ext.data.validator.BoundValidator {
  /**
   * @param config @inheritDoc
   */
  public function LengthValidator(config:ext.data.validator.LengthValidator = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The error message to return when the value length is not in the specified
   * range and both the minimum and maximum are specified.
   * @default 'Length must be between {0} and {1}'
   * @see #getBothMessage()
   * @see #setBothMessage()
   */
  override public native function get bothMessage():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  override public native function set bothMessage(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The error message to return when the value is more than the maximum
   * length and only a maximum is specified.
   * @default 'Length must be no more than {0}'
   * @see #getMaxOnlyMessage()
   * @see #setMaxOnlyMessage()
   */
  override public native function get maxOnlyMessage():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  override public native function set maxOnlyMessage(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The error message to return when the value is less than the minimum
   * length and only a minimum is specified.
   * @default 'Length must be at least {0}'
   * @see #getMinOnlyMessage()
   * @see #setMinOnlyMessage()
   */
  override public native function get minOnlyMessage():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  override public native function set minOnlyMessage(value:String):void;

  /**
   * Returns the value of <a href="#!/api/Ext.data.validator.Length-cfg-bothMessage" rel="Ext.data.validator.Length-cfg-bothMessage" class="docClass">bothMessage</a>.
   */
  public native function getBothMessage():String;

  /**
   * Sets the value of <a href="#!/api/Ext.data.validator.Length-cfg-bothMessage" rel="Ext.data.validator.Length-cfg-bothMessage" class="docClass">bothMessage</a>.
   * @param bothMessage The new value.
   */
  public native function setBothMessage(bothMessage:String):void;
}
}