package ext.data.validator {

[Uses("ext.data.validator.Validator")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.data.validator.Presence", require)]
/**
 * Validates that the passed value is not <code>null</code> or <code>undefined</code> or <code>''</code>.
 */
public class PresenceValidator extends ext.data.validator.Validator {
  /**
   * @param config @inheritDoc
   */
  public function PresenceValidator(config:ext.data.validator.PresenceValidator = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * <code>true</code> to allow <code>''</code> as a valid value.
   * @default false
   * @see #getAllowEmpty()
   * @see #setAllowEmpty()
   */
  public native function get allowEmpty():Boolean;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set allowEmpty(value:Boolean):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The error message to return when the value is not specified.
   * @default 'Must be present'
   * @see #getMessage()
   * @see #setMessage()
   */
  public native function get message():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set message(value:String):void;

  /**
   * Returns the value of <a href="#!/api/Ext.data.validator.Presence-cfg-allowEmpty" rel="Ext.data.validator.Presence-cfg-allowEmpty" class="docClass">allowEmpty</a>.
   */
  public native function getAllowEmpty():Boolean;

  /**
   * Returns the value of <a href="#!/api/Ext.data.validator.Presence-cfg-message" rel="Ext.data.validator.Presence-cfg-message" class="docClass">message</a>.
   */
  public native function getMessage():String;

  /**
   * Sets the value of <a href="#!/api/Ext.data.validator.Presence-cfg-allowEmpty" rel="Ext.data.validator.Presence-cfg-allowEmpty" class="docClass">allowEmpty</a>.
   * @param allowEmpty The new value.
   */
  public native function setAllowEmpty(allowEmpty:Boolean):void;

  /**
   * Sets the value of <a href="#!/api/Ext.data.validator.Presence-cfg-message" rel="Ext.data.validator.Presence-cfg-message" class="docClass">message</a>.
   * @param message The new value.
   */
  public native function setMessage(message:String):void;
}
}