package ext.dd {
import ext.event.Event;
import js.HTMLElement;

[Uses("ext.dd.DragDrop")]
[Uses("ext.Base")]
[Native("Ext.dd.DDTarget", require)]
/**
 * A DragDrop implementation that does not move, but can be a drop
 * target.  You would get the same result by simply omitting implementation
 * for the event callbacks, but this way we reduce the processing cost of the
 * event listener and the callbacks.
 */
public class DDTarget extends ext.dd.DragDrop {
  /**
   * Creates new DDTarget.
   * @param id the id of the element that is a drop target
   * @param sGroup the group of related DragDrop objects
   * @param config an object containing configurable attributes.
   * Valid properties for DDTarget in addition to those in DragDrop: none.
   */
  public function DDTarget(id:String, sGroup:String, config:Object) {
    super(null, null, null);
  }

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param cssClass the class of the elements you wish to ignore
   */
  override public native function addInvalidHandleClass(cssClass:String):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param id the element id of the element you wish to ignore
   */
  override public native function addInvalidHandleId(id:String):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param tagName the type of element to exclude
   */
  override public native function addInvalidHandleType(tagName:String):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   */
  override public native function clearConstraints():void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   */
  override public native function clearTicks():void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param e the mouseup event
   */
  override public native function endDrag(e:ext.event.Event):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   */
  override public native function getDragEl():js.HTMLElement;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param node the HTMLElement to evaluate
   */
  override public native function isValidHandleChild(node:js.HTMLElement):Boolean;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param e the mousemove event
   */
  override public native function onDrag(e:ext.event.Event):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param e the mouseup event
   * @param id In POINT mode, the element
   * id this was dropped on.  In INTERSECT mode, an array of dd items this
   * was dropped on.
   */
  override public native function onDragDrop(e:ext.event.Event, id:*):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param e the mousemove event
   * @param id In POINT mode, the element
   * id this is hovering over.  In INTERSECT mode, an array of one or more
   * dragdrop items being hovered over.
   */
  override public native function onDragEnter(e:ext.event.Event, id:*):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param e the mousemove event
   * @param id In POINT mode, the element
   * id this was hovering over.  In INTERSECT mode, an array of dd items
   * that the mouse is no longer over.
   */
  override public native function onDragOut(e:ext.event.Event, id:*):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param e the mousemove event
   * @param id In POINT mode, the element
   * id this is hovering over.  In INTERSECT mode, an array of dd items
   * being hovered over.
   */
  override public native function onDragOver(e:ext.event.Event, id:*):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param e the mouseup event
   */
  override public native function onInvalidDrop(e:ext.event.Event):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param e the mousedown event
   */
  override public native function onMouseDown(e:ext.event.Event):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param e the mouseup event
   */
  override public native function onMouseUp(e:ext.event.Event):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param cssClass the class of the element(s) you wish to
   * re-enable
   */
  override public native function removeInvalidHandleClass(cssClass:String):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param id the id of the element to re-enable
   */
  override public native function removeInvalidHandleId(id:String):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param tagName the type of element to unexclude
   */
  override public native function removeInvalidHandleType(tagName:String):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   */
  override public native function resetConstraints(maintainOffset:Boolean):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param id the id of the element that will be used to initiate the drag
   */
  override public native function setDragElId(id:String):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param id the id of the element that will be used to
   * initiate the drag.
   */
  override public native function setHandleElId(id:String):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param diffX the X offset, default 0
   * @param diffY the Y offset, default 0
   */
  override public native function setInitPosition(diffX:Number, diffY:Number):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param id the id of the element that will be used to initiate the drag
   */
  override public native function setOuterHandleElId(id:String):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param iLeft the number of pixels the element can move to the left
   * @param iRight the number of pixels the element can move to the
   * right
   * @param iTickSize parameter for specifying that the
   * element should move iTickSize pixels at a time.
   */
  override public native function setXConstraint(iLeft:Number, iRight:Number, iTickSize:Number = NaN):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param iUp the number of pixels the element can move up
   * @param iDown the number of pixels the element can move down
   * @param iTickSize parameter for specifying that the
   * element should move iTickSize pixels at a time.
   */
  override public native function setYConstraint(iUp:Number, iDown:Number, iTickSize:Number = NaN):void;

  /**
   * Overridden and disabled. A DDTarget does not support being dragged.
   * @param x X click location
   * @param y Y click location
   */
  override public native function startDrag(x:Number, y:Number):void;
}
}