package ext.direct {

[Uses("ext.direct.DirectEvent")]
[Uses("ext.Base")]
[Native("Ext.direct.RemotingEvent", require)]
/**
 * An event that is fired when data is received from a
 * <a href="#!/api/Ext.direct.RemotingProvider" rel="Ext.direct.RemotingProvider" class="docClass">Ext.direct.RemotingProvider</a>. Contains a method to the
 * related transaction for the direct request, see <a href="#!/api/Ext.direct.RemotingEvent-method-getTransaction" rel="Ext.direct.RemotingEvent-method-getTransaction" class="docClass">getTransaction</a>
 */
public class RemotingEvent extends ext.direct.DirectEvent {
  /**
   * @param config @inheritDoc
   */
  public function RemotingEvent(config:ext.direct.RemotingEvent = null) {
    super();
  }

  /**
   * Get the transaction associated with this event.
   * @return The transaction
   */
  public native function getTransaction():ext.direct.Transaction;
}
}