package ext.dom {

[Uses("ext.dom.CompositeElementLite")]
[Uses("ext.dom.Element")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Uses("ext.util.Positionable")]
[Native("Ext.dom.CompositeElement", require)]
/**
 * This class encapsulates a <em>collection</em> of DOM elements, providing methods to filter members, or to perform collective
 * actions upon the whole set.
 *
 * <p>Although they are not listed, this class supports all of the methods of <a href="#!/api/Ext.dom.Element" rel="Ext.dom.Element" class="docClass">Ext.dom.Element</a>. The methods from
 * these classes will be performed on all the elements in this collection.</p>
 *
 * <p>All methods return <em>this</em> and can be chained.</p>
 *
 * <p>Usage:</p>
 *
 * <pre><code> var els = <a href="#!/api/Ext-method-select" rel="Ext-method-select" class="docClass">Ext.select</a>("#some-el div.some-class", true);
 *  // or select directly from an existing element
 *  var el = <a href="#!/api/Ext-method-get" rel="Ext-method-get" class="docClass">Ext.get</a>('some-el');
 *  el.select('div.some-class', true);
 *
 *  els.setWidth(100); // all elements become 100 width
 *  els.hide(true); // all elements fade out and hide
 *  // or
 *  els.setWidth(100).hide(true);
 * </code></pre>
 */
public class CompositeElement extends ext.dom.CompositeElementLite {
  /**
   * @inheritDoc
   */
  public function CompositeElement(elements:Array) {
    super(null);
  }
}
}