package ext.dom {

[Uses("ext.dom.Underlay")]
[Uses("ext.Base")]
[Native("Ext.dom.Shadow", require)]
[ExcludeClass]
/**
 * Simple class that can provide a shadow effect for any absolutely positioned <a href="#!/api/Ext.dom.Element" rel="Ext.dom.Element" class="docClass">Element</a>.
 *
 * <p>Not meant to be used directly. To apply a shadow to an Element use the
 * <a href="#!/api/Ext.dom.Element-method-enableShadow" rel="Ext.dom.Element-method-enableShadow" class="docClass">enableShadow</a> method.</p>
 */
public class Shadow extends ext.dom.Underlay {
  /**
   * Creates new Shadow.
   * @param config Config object.
   */
  public function Shadow(config:Object = null) {
    super();
  }

  /**
   * The offsets used for positioning the shadow element
   * relative to its target element
   */
  public native function get offsets():Object;

  /**
   * @private
   */
  public native function set offsets(value:Object):void;

  /**
   * Offsets that represent the union of the areas
   * of the target element and the shadow combined.  Used by <a href="#!/api/Ext.dom.Element" rel="Ext.dom.Element" class="docClass">Ext.dom.Element</a> for
   * ensuring that the shim (if present) extends under the full area of both elements.
   */
  public native function get outerOffsets():Object;

  /**
   * @private
   */
  public native function set outerOffsets(value:Object):void;

  [ExtConfig]
  /**
   * The shadow display mode.  Supports the following options:
   *
   * <ul>
   * <li>sides : Shadow displays on both sides and bottom only</li>
   * <li>frame : Shadow displays equally on all four sides</li>
   * <li>drop : Traditional bottom-right drop shadow</li>
   * </ul>
   * @default 'drop'
   */
  public native function get mode():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set mode(value:String):void;

  [ExtConfig]
  /**
   * The number of pixels to offset the shadow from the element
   * @default 4
   */
  public native function get offset():Number;

  [ExtConfig]
  /**
   * @private
   */
  public native function set offset(value:Number):void;

  /**
   * Sets the opacity of the shadow
   * @param opacity The opacity
   */
  public native function setOpacity(opacity:Number):void;
}
}