package ext.dom.events {
import ext.event.Event;
import js.HTMLElement;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class Element_event_node_optionsEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires when there is a double tap.
   * @see ext.dom.Element
   * @eventType onDoubleTap
   */
  public static const DOUBLE_TAP:String = "onDoubleTap";

  /**
   * "Fires when you touch and hold still for more than 1 second.
   * @see ext.dom.Element
   * @eventType onLongPress
   */
  public static const LONG_PRESS:String = "onLongPress";

  /**
   * "Fires continuously when there is pinching (the touch must move for this to be fired).
   * @see ext.dom.Element
   * @eventType onPinch
   */
  public static const PINCH:String = "onPinch";

  /**
   * "Fires when a pinch has ended.
   * @see ext.dom.Element
   * @eventType onPinchEnd
   */
  public static const PINCH_END:String = "onPinchEnd";

  /**
   * "Fired once when a pinch has started.
   * @see ext.dom.Element
   * @eventType onPinchStart
   */
  public static const PINCH_START:String = "onPinchStart";

  /**
   * "Fires continuously when there is rotation (the touch must move for this to be fired).
   * When listening to this, ensure you know about the <a href="#!/api/Ext.event.Event-property-angle" rel="Ext.event.Event-property-angle" class="docClass">Ext.event.Event.angle</a> and <a href="#!/api/Ext.event.Event-property-rotation" rel="Ext.event.Event-property-rotation" class="docClass">Ext.event.Event.rotation</a>
   * properties in the <code>event</code> object.
   * @see ext.dom.Element
   * @eventType onRotate
   */
  public static const ROTATE:String = "onRotate";

  /**
   * "Fires when a rotation event has ended.
   * @see ext.dom.Element
   * @eventType onRotateEnd
   */
  public static const ROTATE_END:String = "onRotateEnd";

  /**
   * "Fired once when a rotation has started.
   * @see ext.dom.Element
   * @eventType onRotateStart
   */
  public static const ROTATE_START:String = "onRotateStart";

  /**
   * "Fires when there is a single tap.
   * @see ext.dom.Element
   * @eventType onSingleTap
   */
  public static const SINGLE_TAP:String = "onSingleTap";

  /**
   * "Fires when there is a swipe
   * When listening to this, ensure you know about the <a href="#!/api/Ext.event.Event-property-direction" rel="Ext.event.Event-property-direction" class="docClass">Ext.event.Event.direction</a> property in the <code>event</code> object.
   * @see ext.dom.Element
   * @eventType onSwipe
   */
  public static const SWIPE:String = "onSwipe";

  /**
   * "Fires when you touch and hold still for more than 1 second.
   * @see ext.dom.Element
   * @eventType onTapHold
   */
  public static const TAP_HOLD:String = "onTapHold";

  public function Element_event_node_optionsEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The <a href="#!/api/Ext.event.Event" rel="Ext.event.Event" class="docClass">Ext.event.Event</a> event encapsulating the DOM event.
   */
  public native function get event():ext.event.Event;

  /**
   * The target of the event.
   */
  public native function get node():js.HTMLElement;

  /**
   * The options object passed to <a href="#!/api/Ext.mixin.Observable-method-addListener" rel="Ext.mixin.Observable-method-addListener" class="docClass">Ext.mixin.Observable.addListener</a>.
   */
  public native function get options():Object;
}
}