package ext.drag.proxy {

[Uses("ext.drag.proxy.NoneDragProxy")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.drag.proxy.Placeholder", require)]
/**
 * A drag proxy that creates a new element to follow the cursor.
 */
public class PlaceholderDragProxy extends ext.drag.proxy.NoneDragProxy {
  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * A class for this proxy.
   * @default ''
   * @see #getCls()
   * @see #setCls()
   */
  public native function get cls():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set cls(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * Determines the position of the proxy in relation
   * to the cursor.
   * @default [12, 20]
   * @see #getCursorOffset()
   * @see #setCursorOffset()
   */
  public native function get cursorOffset():Array;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set cursorOffset(value:Array):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The html for this proxy.
   * @see #getHtml()
   * @see #setHtml()
   */
  public native function get html():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set html(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * A class to add to this proxy when over an
   * invalid <a href="#!/api/Ext.drag.Target" rel="Ext.drag.Target" class="docClass">target</a>.
   * @default ''
   * @see #getInvalidCls()
   * @see #setInvalidCls()
   */
  public native function get invalidCls():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set invalidCls(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * A class to add to this proxy when over a
   * valid <a href="#!/api/Ext.drag.Target" rel="Ext.drag.Target" class="docClass">target</a>.
   * @default ''
   * @see #getValidCls()
   * @see #setValidCls()
   */
  public native function get validCls():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set validCls(value:String):void;

  /**
   * Returns the value of <a href="#!/api/Ext.drag.proxy.Placeholder-cfg-cls" rel="Ext.drag.proxy.Placeholder-cfg-cls" class="docClass">cls</a>.
   */
  public native function getCls():String;

  /**
   * Returns the value of <a href="#!/api/Ext.drag.proxy.Placeholder-cfg-cursorOffset" rel="Ext.drag.proxy.Placeholder-cfg-cursorOffset" class="docClass">cursorOffset</a>.
   */
  public native function getCursorOffset():Array;

  /**
   * Returns the value of <a href="#!/api/Ext.drag.proxy.Placeholder-cfg-html" rel="Ext.drag.proxy.Placeholder-cfg-html" class="docClass">html</a>.
   */
  public native function getHtml():String;

  /**
   * Returns the value of <a href="#!/api/Ext.drag.proxy.Placeholder-cfg-invalidCls" rel="Ext.drag.proxy.Placeholder-cfg-invalidCls" class="docClass">invalidCls</a>.
   */
  public native function getInvalidCls():String;

  /**
   * Returns the value of <a href="#!/api/Ext.drag.proxy.Placeholder-cfg-validCls" rel="Ext.drag.proxy.Placeholder-cfg-validCls" class="docClass">validCls</a>.
   */
  public native function getValidCls():String;

  /**
   * Sets the value of <a href="#!/api/Ext.drag.proxy.Placeholder-cfg-cls" rel="Ext.drag.proxy.Placeholder-cfg-cls" class="docClass">cls</a>.
   * @param cls The new value.
   */
  public native function setCls(cls:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.drag.proxy.Placeholder-cfg-cursorOffset" rel="Ext.drag.proxy.Placeholder-cfg-cursorOffset" class="docClass">cursorOffset</a>.
   * @param cursorOffset The new value.
   */
  public native function setCursorOffset(cursorOffset:Array):void;

  /**
   * Sets the value of <a href="#!/api/Ext.drag.proxy.Placeholder-cfg-html" rel="Ext.drag.proxy.Placeholder-cfg-html" class="docClass">html</a>.
   * @param html The new value.
   */
  public native function setHtml(html:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.drag.proxy.Placeholder-cfg-invalidCls" rel="Ext.drag.proxy.Placeholder-cfg-invalidCls" class="docClass">invalidCls</a>.
   * @param invalidCls The new value.
   */
  public native function setInvalidCls(invalidCls:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.drag.proxy.Placeholder-cfg-validCls" rel="Ext.drag.proxy.Placeholder-cfg-validCls" class="docClass">validCls</a>.
   * @param validCls The new value.
   */
  public native function setValidCls(validCls:String):void;
}
}