package ext.event.gesture {

[Uses("ext.event.gesture.SingleTouch")]
[Uses("ext.event.gesture.GestureRecognizer")]
[Uses("ext.mixin.Identifiable")]
[Uses("ext.Base")]
[Native("Ext.event.gesture.Drag", require)]
public class Drag extends ext.event.gesture.SingleTouch {
  /**
   * @param config @inheritDoc
   */
  public function Drag(config:ext.event.gesture.Drag = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The minimum distance of pixels before a touch event becomes a drag event.
   * @default 8
   * @see #getMinDistance()
   * @see #setMinDistance()
   */
  public native function get minDistance():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set minDistance(value:Number):void;

  /**
   * Returns the value of <a href="#!/api/Ext.event.gesture.Drag-cfg-minDistance" rel="Ext.event.gesture.Drag-cfg-minDistance" class="docClass">minDistance</a>.
   */
  public native function getMinDistance():Number;

  /**
   * Sets the value of <a href="#!/api/Ext.event.gesture.Drag-cfg-minDistance" rel="Ext.event.gesture.Drag-cfg-minDistance" class="docClass">minDistance</a>.
   * @param minDistance The new value.
   */
  public native function setMinDistance(minDistance:Number):void;
}
}