package ext.events {
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class GlobalEventsEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires when an event handler finishes its run, just before returning to
   * browser control.
   *
   * <p>This includes DOM event handlers, Ajax (including JSONP) event handlers,
   * and <a href="#!/api/Ext.util.TaskRunner" rel="Ext.util.TaskRunner" class="docClass">TaskRunners</a></p>
   *
   * <p>When called at the tail of a DOM event, the event object is passed as the
   * sole parameter.</p>
   *
   * <p>This can be useful for performing cleanup, or update tasks which need to
   * happen only after all code in an event handler has been run, but which
   * should not be executed in a timer due to the intervening browser
   * reflow/repaint which would take place.</p>
   * @see ext.SGlobalEvents
   * @eventType onIdle
   */
  public static const IDLE:String = "onIdle";

  /**
   * "Fires after global layout processing has been resumed in <a href="#!/api/Ext.Component-method-resumeLayouts" rel="Ext.Component-method-resumeLayouts" class="docClass">Ext.Component.resumeLayouts</a>.
   * @see ext.SGlobalEvents
   * @eventType onResumeLayouts
   */
  public static const RESUME_LAYOUTS:String = "onResumeLayouts";

  public function GlobalEventsEvent(type:String, arguments:Array) {
    super(null, null);
  }
}
}