package ext.form.trigger {

[Uses("ext.form.trigger.Trigger")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.form.trigger.Spinner", require)]
/**
 * A Trigger that contains 2 clickable elements inside in the form of a "up" and a "down"
 * trigger.
 */
public class SpinnerTrigger extends ext.form.trigger.Trigger {
  /**
   * @param config @inheritDoc
   */
  public function SpinnerTrigger(config:ext.form.trigger.SpinnerTrigger = null) {
    super();
  }

  [ExtConfig]
  /**
   * The handler for the 'down' button
   * &#64;controllable
   * @default undefined
   */
  public native function get downHandler():*;

  [ExtConfig]
  /**
   * @private
   */
  public native function set downHandler(value:*):void;

  [ExtConfig]
  /**
   * The handler for the 'up' button
   * &#64;controllable
   * @default undefined
   */
  public native function get upHandler():*;

  [ExtConfig]
  /**
   * @private
   */
  public native function set upHandler(value:*):void;

  [ExtConfig]
  /**
   * True to layout the spinner in a vertical format.
   *
   * <p><strong>Note:</strong> This is not intended to be configured on an instance level, but is
   * meant to be overridden by mobile-friendly themes that provide styling for
   * vertically oriented triggers.</p>
   * @default true
   */
  public native function get vertical():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set vertical(value:Boolean):void;
}
}