package ext.fx.target {

[Uses("ext.fx.target.ElementTarget")]
[Uses("ext.fx.target.Target")]
[Uses("ext.Base")]
[Native("Ext.fx.target.CompositeElement", require)]
/**
 * This class represents a animation target for a <a href="#!/api/Ext.dom.CompositeElement" rel="Ext.dom.CompositeElement" class="docClass">Ext.CompositeElement</a>. It allows
 * each <a href="#!/api/Ext.dom.Element" rel="Ext.dom.Element" class="docClass">Ext.dom.Element</a> in the group to be animated as a whole. In general this class will not be
 * created directly, the <a href="#!/api/Ext.dom.CompositeElement" rel="Ext.dom.CompositeElement" class="docClass">Ext.CompositeElement</a> will be passed to the animation and
 * and the appropriate target will be created.
 */
public class CompositeElementTarget extends ext.fx.target.ElementTarget {
  /**
   * @inheritDoc
   */
  public function CompositeElementTarget(target:* = undefined) {
    super();
  }

  /**
   * <code>true</code> in this class to identify an object as an instantiated CompositeElement, or subclass thereof.
   * @default true
   */
  public native function get isComposite():Boolean;

  /**
   * @private
   */
  public native function set isComposite(value:Boolean):void;
}
}