package ext.fx.target {
import ext.Base;

[Uses("ext.Base")]
[Native("Ext.fx.target.Target", require)]
/**
 * This class specifies a generic target for an animation. It provides a wrapper around a
 * series of different types of objects to allow for a generic animation API.
 * A target can be a single object or a Composite object containing other objects that are
 * to be animated. This class and it's subclasses are generally not created directly, the
 * underlying animation will create the appropriate <a href="#!/api/Ext.fx.target.Target" rel="Ext.fx.target.Target" class="docClass">Ext.fx.target.Target</a> object by passing
 * the instance to be animated.
 *
 * <p>The following types of objects can be animated:</p>
 *
 * <ul>
 * <li><a href="#!/api/Ext.fx.target.Component" rel="Ext.fx.target.Component" class="docClass">Components</a></li>
 * <li><a href="#!/api/Ext.fx.target.Element" rel="Ext.fx.target.Element" class="docClass">Elements</a></li>
 * <li><a href="#!/api/Ext.fx.target.Sprite" rel="Ext.fx.target.Sprite" class="docClass">Sprites</a></li>
 * </ul>
 */
public class Target extends ext.Base {
  /**
   * Creates new Target.
   * @param target The object to be animated
   */
  public function Target(target:*) {
    super();
  }
}
}