package ext.grid.column.events {
import ext.data.Model;
import ext.event.Event;
import ext.grid.column.CheckColumn;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class CheckColumn_rowIndex_checked_record_eEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires when the UI requests a change of check status.
   * The change may be vetoed by returning <code>false</code> from a listener.
   * @see ext.grid.column.CheckColumn
   * @eventType onBeforeCheckChange
   */
  public static const BEFORE_CHECK_CHANGE:String = "onBeforeCheckChange";

  /**
   * "Fires when the UI has successfully changed the checked state of a row.
   * @see ext.grid.column.CheckColumn
   * @eventType onCheckChange
   */
  public static const CHECK_CHANGE:String = "onCheckChange";

  public function CheckColumn_rowIndex_checked_record_eEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * CheckColumn.
   */
  public native function get source():ext.grid.column.CheckColumn;

  /**
   * The row index.
   */
  public native function get rowIndex():Number;

  /**
   * <code>true</code> if the box is to be checked.
   */
  public native function get checked():Boolean;

  /**
   * The record to be updated.
   */
  public native function get record():ext.data.Model;

  /**
   * The underlying event which caused the check change.
   * <ul>
   *   <li><code>position</code> : ext.grid.CellContext
   * A <a href="#!/api/Ext.grid.CellContext" rel="Ext.grid.CellContext" class="docClass">CellContext</a> object
   * containing all contextual information about where the event was triggered.
   *   </li>
   * </ul>
   */
  public native function get e():ext.event.Event;
}
}