package ext.grid.feature {

[Uses("ext.grid.feature.Feature")]
[Uses("ext.util.Observable")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Native("Ext.grid.feature.AbstractSummary", require)]
/**
 * A small abstract class that contains the shared behaviour for any summary
 * calculations to be used in the grid.
 */
public class AbstractSummary extends ext.grid.feature.Feature implements ext.grid.feature.IAbstractSummary {
  /**
   * @param config @inheritDoc
   */
  public function AbstractSummary(config:ext.grid.feature.AbstractSummary = null) {
    super();
  }

  [ExtConfig]
  /**
   * True to show the summary row.
   * @default true
   */
  public native function get showSummaryRow():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set showSummaryRow(value:Boolean):void;

  /**
   * Toggle whether or not to show the summary row.
   * @param visible True to show the summary row
   */
  public native function toggleSummaryRow(visible:Boolean):void;
}
}