package ext.grid.feature {

[Uses("ext.grid.feature.Feature")]
[Uses("ext.grid.feature.AbstractSummary")]
[Uses("ext.util.Observable")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Mixin("ext.grid.feature.AbstractSummary")]
/**
 * A small abstract class that contains the shared behaviour for any summary
 * calculations to be used in the grid.
 * @see ext.grid.feature.AbstractSummary
 */
public interface IAbstractSummary extends ext.grid.feature.IFeature {
  [ExtConfig]
  /**
   * True to show the summary row.
   * @default true
   */
  function get showSummaryRow():Boolean;

  [ExtConfig]
  function set showSummaryRow(value:Boolean):void;

  /**
   * Toggle whether or not to show the summary row.
   * @param visible True to show the summary row
   */
  function toggleSummaryRow(visible:Boolean):void;
}
}