package ext.grid.plugin {
import ext.plugin.AbstractClipboardPlugin;

[Uses("ext.plugin.AbstractClipboardPlugin")]
[Uses("ext.plugin.AbstractPlugin")]
[Uses("ext.Plugin")]
[Uses("ext.Base")]
[Native("Ext.grid.plugin.Clipboard", require)]
/**
 * This <a href="#!/api/Ext.grid.Panel" rel="Ext.grid.Panel" class="docClass">grid</a> plugin adds clipboard support to a grid.
 *
 * <p><em>Note that the grid must use the <a href="#!/api/Ext.grid.selection.SpreadsheetModel" rel="Ext.grid.selection.SpreadsheetModel" class="docClass">spreadsheet selection model</a> to utilize this plugin.</em></p>
 *
 * <p>This class supports the following <code><a href="#!/api/Ext.plugin.AbstractClipboard-cfg-formats" rel="Ext.plugin.AbstractClipboard-cfg-formats" class="docClass">formats</a></code>
 * for grid data:</p>
 *
 * <ul>
 * <li><code>cell</code> - Complete field data that can be matched to other grids using the same
 * <a href="#!/api/Ext.data.Model" rel="Ext.data.Model" class="docClass">model</a> regardless of column order.</li>
 * <li><code>text</code> - Cell content stripped of HTML tags.</li>
 * <li><code>html</code> - Complete cell content, including any rendered HTML tags.</li>
 * <li><code>raw</code> - Underlying field values based on <code>dataIndex</code>.</li>
 * </ul>
 *
 *
 * <p>The <code>cell</code> format is not valid for the <code><a href="#!/api/Ext.plugin.AbstractClipboard-cfg-system" rel="Ext.plugin.AbstractClipboard-cfg-system" class="docClass">system</a></code>
 * clipboard format.</p>
 */
public class GridClipboardPlugin extends ext.plugin.AbstractClipboardPlugin {
  /**
   * @param config @inheritDoc
   */
  public function GridClipboardPlugin(config:ext.grid.plugin.GridClipboardPlugin = null) {
    super();
  }
}
}