package ext.grid.property {
import ext.data.Model;
import ext.data.Session;

[Uses("ext.data.Model")]
[Uses("ext.Base")]
[Native("Ext.grid.property.Property", require)]
/**
 * A specific <a href="#!/api/Ext.data.Model" rel="Ext.data.Model" class="docClass">Ext.data.Model</a> type that represents a name/value pair and is made to work with the
 * <a href="#!/api/Ext.grid.property.Grid" rel="Ext.grid.property.Grid" class="docClass">Ext.grid.property.Grid</a>. Typically, Properties do not need to be created directly as they can be
 * created implicitly by simply using the appropriate data configs either via the
 * <a href="#!/api/Ext.grid.property.Grid-cfg-source" rel="Ext.grid.property.Grid-cfg-source" class="docClass">Ext.grid.property.Grid.source</a> config property or by calling <a href="#!/api/Ext.grid.property.Grid-method-setSource" rel="Ext.grid.property.Grid-method-setSource" class="docClass">Ext.grid.property.Grid.setSource</a>.
 * However, if the need arises, these records can also be created explicitly as shown below. Example usage:
 *
 * <pre><code>var rec = new <a href="#!/api/Ext.grid.property.Property" rel="Ext.grid.property.Property" class="docClass">Ext.grid.property.Property</a>({
 *     name: 'birthday',
 *     value: <a href="#!/api/Ext.Date-method-parse" rel="Ext.Date-method-parse" class="docClass">Ext.Date.parse</a>('17/06/1962', 'd/m/Y')
 * });
 * // Add record to an already populated grid
 * grid.store.addSorted(rec);
 * </code></pre>
 */
public class Property extends ext.data.Model {
  /**
   * Creates new property.
   * @param config A data object in the format:
   * @param config.name A name or names for the property.
   * @param config.value A value or values for the property.
   * The specified value's type will be read automatically by the grid to determine the type of editor to use when
   * displaying it.
   */
  public function Property(data:Object, session:ext.data.Session = null) {
    super(null);
  }
}
}