package ext.grid.property {
import ext.data.Store;
import ext.grid.GridPanel;

[Uses("ext.data.Store")]
[Uses("ext.data.LocalStore")]
[Uses("ext.Mixin")]
[Uses("ext.Base")]
[Uses("ext.data.ProxyStore")]
[Uses("ext.data.AbstractStore")]
[Uses("ext.mixin.Observable")]
[Uses("ext.mixin.Factoryable")]
[Native("Ext.grid.property.Store", require)]
/**
 * A custom <a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a> for the <a href="#!/api/Ext.grid.property.Grid" rel="Ext.grid.property.Grid" class="docClass">Ext.grid.property.Grid</a>. This class handles the mapping
 * between the custom data source objects supported by the grid and the <a href="#!/api/Ext.grid.property.Property" rel="Ext.grid.property.Property" class="docClass">Ext.grid.property.Property</a> format
 * used by the <a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a> base class.
 */
public class PropertyStore extends ext.data.Store {
  /**
   * Creates new property store.
   * @param grid The grid this store will be bound to
   * @param source The source data config object
   */
  public function PropertyStore(grid:ext.grid.GridPanel, source:Object) {
    super();
  }

  /**
   * Should only be called by the grid.  Use grid.getSource instead.
   */
  protected native function getSource():Object;
}
}