package ext.grid.selection {
import ext.grid.column.Column;

[Uses("ext.grid.selection.Selection")]
[Uses("ext.Base")]
[Native("Ext.grid.selection.Columns", require)]
/**
 * A class which encapsulates a range of columns defining a selection in a grid.
 */
public class ColumnsSelection extends ext.grid.selection.Selection {
  /**
   * This property indicates the this selection represents selected columns.
   * @default true
   */
  public native function get isColumns():Boolean;

  /**
   * Returns <code>true</code> if the passed <a href="#!/api/Ext.grid.column.Column" rel="Ext.grid.column.Column" class="docClass">column</a> is selected.
   * @param column The column to test.
   * @return <code>true</code> if the passed <a href="#!/api/Ext.grid.column.Column" rel="Ext.grid.column.Column" class="docClass">column</a> is selected.
   */
  public native function contains(column:ext.grid.column.Column):Boolean;

  /**
   * Returns the columns selected.
   * @return The columns selected.
   */
  public native function getColumns():Array;

  /**
   * Returns the number of columns selected.
   * @return The number of columns selected.
   */
  public native function getCount():Number;
}
}