package ext.layout.component {
import ext.dom.Element;
import ext.layout.Layout;

[Uses("ext.layout.Layout")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.layout.component.Component", require)]
[ExcludeClass]
/**
 * This class is intended to be extended or created via the <a href="#!/api/Ext.Component-cfg-componentLayout" rel="Ext.Component-cfg-componentLayout" class="docClass">layout</a>
 * configuration property.  See <a href="#!/api/Ext.Component-cfg-componentLayout" rel="Ext.Component-cfg-componentLayout" class="docClass">Ext.Component.componentLayout</a> for additional details.
 */
public class ComponentLayout extends ext.layout.Layout {
  /**
   * @inheritDoc
   */
  public function ComponentLayout(config:ext.layout.Layout = null) {
    super();
  }

  /**
   * Returns the element into which rendering must take place. Defaults to the owner Component's encapsulating element.
   *
   * <p>May be overridden in Component layout managers which implement an inner element.</p>
   */
  public native function getRenderTarget():ext.dom.Element;

  /**
   * Returns the owner component's resize element.
   */
  public native function getTarget():ext.dom.Element;
}
}