package ext.list {

[Uses("ext.list.AbstractTreeItem")]
[Uses("ext.Widget")]
[Uses("ext.mixin.Pluggable")]
[Uses("ext.Base")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.Evented")]
[Uses("ext.mixin.Observable")]
[Native("Ext.list.TreeItem", require)]
/**
 * The default implementation of the class used for <code><a href="#!/api/Ext.list.Tree" rel="Ext.list.Tree" class="docClass">Ext.list.Tree</a></code>.
 *
 * <p>This class can only be used in conjunction with <a href="#!/api/Ext.list.Tree" rel="Ext.list.Tree" class="docClass">Ext.list.Tree</a>.</p>
 */
public class TreeItem extends ext.list.AbstractTreeItem {
  /**
   * @param config @inheritDoc
   */
  public function TreeItem(config:ext.list.TreeItem = null) {
    super();
  }

  /**
   * This property is <code>true</code> to allow type checking for this or derived class.
   * @default true
   */
  public native function get isTreeListItem():Boolean;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * One or more CSS classes to add to the tree item's logical "row" element. This
   * element fills from left-to-right of the line.
   * @since 6.0.1
   * @see #getRowCls()
   * @see #setRowCls()
   */
  public native function get rowCls():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set rowCls(value:String):void;

  [ExtConfig]
  /**
   * The name of the associated record's field to map to the <a href="#!/api/Ext.list.TreeItem-cfg-rowCls" rel="Ext.list.TreeItem-cfg-rowCls" class="docClass">rowCls</a> config.
   * @default "rowCls"
   * @since 6.0.1
   */
  public native function get rowClsProperty():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set rowClsProperty(value:String):void;

  /**
   * Returns the value of <a href="#!/api/Ext.list.TreeItem-cfg-rowCls" rel="Ext.list.TreeItem-cfg-rowCls" class="docClass">rowCls</a>.
   * @since 6.0.1
   */
  public native function getRowCls():String;

  /**
   * Sets the value of <a href="#!/api/Ext.list.TreeItem-cfg-rowCls" rel="Ext.list.TreeItem-cfg-rowCls" class="docClass">rowCls</a>.
   * @since 6.0.1
   * @param rowCls The new value.
   */
  public native function setRowCls(rowCls:String):void;
}
}