package ext.panel {
import ext.Component;
import ext.data.Model;
import ext.data.Store;
import ext.grid.header.HeaderContainer;
import ext.grid.locking.ILockable;
import ext.selection.SelectionModel;
import ext.view.TableView;

[Uses("ext.panel.Panel")]
[Uses("ext.grid.locking.Lockable")]
[Uses("ext.Base")]
[Uses("ext.container.Container")]
[Uses("ext.Component")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.util.ElementContainer")]
[Uses("ext.util.Floating")]
[Uses("ext.util.Positionable")]
[Uses("ext.state.Stateful")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.Keyboard")]
[Uses("ext.mixin.Accessible")]
[Uses("ext.mixin.Observable")]
[Uses("ext.util.Renderable")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.util.Focusable")]
[Uses("ext.util.Animate")]
[Uses("ext.mixin.Queryable")]
[Uses("ext.mixin.Container")]
[Uses("ext.container.DockingContainer")]
[Native("Ext.panel.Table", require)]
/**
 * Fired before the cell click is processed. Return false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_CLICK
 */
[Event(name = 'onBeforeCellClick', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired before the cell right click is processed. Return false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_CONTEXT_MENU
 */
[Event(name = 'onBeforeCellContextMenu', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired before the cell double click is processed. Return false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_DBLCLICK
 */
[Event(name = 'onBeforeCellDblclick', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired before the cell key down is processed. Return false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_KEY_DOWN
 */
[Event(name = 'onBeforeCellKeyDown', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired before the cell mouse down is processed. Return false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_MOUSE_DOWN
 */
[Event(name = 'onBeforeCellMouseDown', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired before the cell mouse up is processed. Return false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_MOUSE_UP
 */
[Event(name = 'onBeforeCellMouseUp', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fires before the click event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_eEvent.BEFORE_CONTAINER_CLICK
 */
[Event(name = 'onBeforeContainerClick', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires before the contextmenu event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_eEvent.BEFORE_CONTAINER_CONTEXT_MENU
 */
[Event(name = 'onBeforeContainerContextMenu', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires before the dblclick event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_eEvent.BEFORE_CONTAINER_DBLCLICK
 */
[Event(name = 'onBeforeContainerDblclick', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires before the keydown event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_eEvent.BEFORE_CONTAINER_KEY_DOWN
 */
[Event(name = 'onBeforeContainerKeyDown', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires before the keypress event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_eEvent.BEFORE_CONTAINER_KEYPRESS
 */
[Event(name = 'onBeforeContainerKeypress', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires before the keyup event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_eEvent.BEFORE_CONTAINER_KEY_UP
 */
[Event(name = 'onBeforeContainerKeyUp', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires before the mousedown event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_eEvent.BEFORE_CONTAINER_MOUSE_DOWN
 */
[Event(name = 'onBeforeContainerMouseDown', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires before the mouseout event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_eEvent.BEFORE_CONTAINER_MOUSE_OUT
 */
[Event(name = 'onBeforeContainerMouseOut', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires before the mouseover event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_eEvent.BEFORE_CONTAINER_MOUSE_OVER
 */
[Event(name = 'onBeforeContainerMouseOver', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires before the mouseup event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.panel.events.TablePanel_eEvent.BEFORE_CONTAINER_MOUSE_UP
 */
[Event(name = 'onBeforeContainerMouseUp', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fired before a record is deselected. If any listener returns false, the
 * deselection is cancelled.
 * @eventType ext.panel.events.TablePanel_record_indexEvent.BEFORE_DESELECT
 */
[Event(name = 'onBeforeDeselect', type = 'ext.panel.events.TablePanel_record_indexEvent')]
/**
 * Fires before the click event on an item is processed. Return false to cancel the
 * default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_CLICK
 */
[Event(name = 'onBeforeItemClick', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before the contextmenu event on an item is processed. Return false to
 * cancel the default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_CONTEXT_MENU
 */
[Event(name = 'onBeforeItemContextMenu', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before the dblclick event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_DBLCLICK
 */
[Event(name = 'onBeforeItemDblclick', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before the keydown event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_KEY_DOWN
 */
[Event(name = 'onBeforeItemKeyDown', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before the keypress event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_KEYPRESS
 */
[Event(name = 'onBeforeItemKeypress', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before the keyup event on an item is processed. Return false to cancel the
 * default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_KEY_UP
 */
[Event(name = 'onBeforeItemKeyUp', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before the longpress event on an item is processed. Return false to
 * cancel the default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_LONG_PRESS
 */
[Event(name = 'onBeforeItemLongPress', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before the mousedown event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_MOUSE_DOWN
 */
[Event(name = 'onBeforeItemMouseDown', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before the mouseenter event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_MOUSE_ENTER
 */
[Event(name = 'onBeforeItemMouseEnter', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before the mouseleave event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_MOUSE_LEAVE
 */
[Event(name = 'onBeforeItemMouseLeave', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before the mouseup event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.BEFORE_ITEM_MOUSE_UP
 */
[Event(name = 'onBeforeItemMouseUp', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires before a request is made for a new data object. If the beforeload handler returns false the load
 * action will be canceled.
 * @eventType ext.panel.events.TablePanel_store_operationEvent.BEFORE_LOAD
 */
[Event(name = 'onBeforeLoad', type = 'ext.panel.events.TablePanel_store_operationEvent')]
/**
 * Fires before the click event on a row body element is processed. Return false to
 * cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_CLICK
 */
[Event(name = 'onBeforeRowBodyClick', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires before the contextmenu event on a row body element is processed. Return
 * false to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_CONTEXT_MENU
 */
[Event(name = 'onBeforeRowBodyContextMenu', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires before the dblclick event on a row body element is processed. Return false
 * to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_DBLCLICK
 */
[Event(name = 'onBeforeRowBodyDblclick', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires before the keydown event on a row body element is processed. Return false
 * to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_KEY_DOWN
 */
[Event(name = 'onBeforeRowBodyKeyDown', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires before the keypress event on a row body element is processed. Return false
 * to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_KEYPRESS
 */
[Event(name = 'onBeforeRowBodyKeypress', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires before the keyup event on a row body element is processed. Return false to
 * cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_KEY_UP
 */
[Event(name = 'onBeforeRowBodyKeyUp', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires before the longpress event on a row body element is processed. Return
 * false to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_LONG_PRESS
 */
[Event(name = 'onBeforeRowBodyLongPress', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires before the mousedown event on a row body element is processed. Return false
 * to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_MOUSE_DOWN
 */
[Event(name = 'onBeforeRowBodyMouseDown', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires before the mouseup event on a row body element is processed. Return false
 * to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_MOUSE_UP
 */
[Event(name = 'onBeforeRowBodyMouseUp', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fired when View is asked to exit Actionable mode in the current row,
 * and proceed to the previous/next row. If the handler returns <code>false</code>,
 * View processing is aborted.
 * @eventType ext.panel.events.TablePanel_keyEvent_prevRow_nextRow_forwardEvent.BEFORE_ROW_EXIT
 */
[Event(name = 'onBeforeRowExit', type = 'ext.panel.events.TablePanel_keyEvent_prevRow_nextRow_forwardEvent')]
/**
 * Fired before a record is selected. If any listener returns false, the
 * selection is cancelled.
 * @eventType ext.panel.events.TablePanel_record_indexEvent.BEFORE_SELECT
 */
[Event(name = 'onBeforeSelect', type = 'ext.panel.events.TablePanel_record_indexEvent')]
/**
 * .
 * An event fired when an extension block is extended
 * using a drag gesture.  Only fired when the SpreadsheetSelectionModel is used and
 * configured with the
 * <a href="#!/api/Ext.grid.selection.SpreadsheetModel-cfg-extensible" rel="Ext.grid.selection.SpreadsheetModel-cfg-extensible" class="docClass">extensible</a> config.
 * @eventType ext.panel.events.TablePanel_An_extensionEvent.BEFORE_SELECTION_EXTEND
 */
[Event(name = 'onBeforeSelectionExtend', type = 'ext.panel.events.TablePanel_An_extensionEvent')]
/**
 * Fired when table cell is clicked.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.CELL_CLICK
 */
[Event(name = 'onCellClick', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired when table cell is right clicked.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.CELL_CONTEXT_MENU
 */
[Event(name = 'onCellContextMenu', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired when table cell is double clicked.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.CELL_DBLCLICK
 */
[Event(name = 'onCellDblclick', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired when the keydown event is captured on the cell.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.CELL_KEY_DOWN
 */
[Event(name = 'onCellKeyDown', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired when the mousedown event is captured on the cell.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.CELL_MOUSE_DOWN
 */
[Event(name = 'onCellMouseDown', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired when the mouseup event is captured on the cell.
 * @eventType ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent.CELL_MOUSE_UP
 */
[Event(name = 'onCellMouseUp', type = 'ext.panel.events.TablePanel_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * @eventType ext.panel.events.TablePanel_ct_columnEvent.COLUMN_HIDE
 */
[Event(name = 'onColumnHide', type = 'ext.panel.events.TablePanel_ct_columnEvent')]
/**
 * @eventType ext.panel.events.TablePanel_ct_column_fromIdx_toIdxEvent.COLUMN_MOVE
 */
[Event(name = 'onColumnMove', type = 'ext.panel.events.TablePanel_ct_column_fromIdx_toIdxEvent')]
/**
 * @eventType ext.panel.events.TablePanel_ct_column_widthEvent.COLUMN_RESIZE
 */
[Event(name = 'onColumnResize', type = 'ext.panel.events.TablePanel_ct_column_widthEvent')]
/**
 * Fired after the columns change in any way, when a column has been hidden or shown, or when a column
 * is added to or removed from this header container.
 * @eventType ext.panel.events.TablePanel_ctEvent.COLUMNS_CHANGED
 */
[Event(name = 'onColumnsChanged', type = 'ext.panel.events.TablePanel_ctEvent')]
/**
 * @eventType ext.panel.events.TablePanel_ct_columnEvent.COLUMNS_HOW
 */
[Event(name = 'onColumnsHow', type = 'ext.panel.events.TablePanel_ct_columnEvent')]
/**
 * Fires when the container is clicked.
 * @eventType ext.panel.events.TablePanel_eEvent.CONTAINER_CLICK
 */
[Event(name = 'onContainerClick', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires when the container is right clicked.
 * @eventType ext.panel.events.TablePanel_eEvent.CONTAINER_CONTEXT_MENU
 */
[Event(name = 'onContainerContextMenu', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires when the container is double clicked.
 * @eventType ext.panel.events.TablePanel_eEvent.CONTAINER_DBLCLICK
 */
[Event(name = 'onContainerDblclick', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires when a key is pressed down while the container is focused, and no item is currently selected.
 * @eventType ext.panel.events.TablePanel_eEvent.CONTAINER_KEY_DOWN
 */
[Event(name = 'onContainerKeyDown', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires when a key is pressed while the container is focused, and no item is currently selected.
 * @eventType ext.panel.events.TablePanel_eEvent.CONTAINER_KEYPRESS
 */
[Event(name = 'onContainerKeypress', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires when a key is released while the container is focused, and no item is currently selected.
 * @eventType ext.panel.events.TablePanel_eEvent.CONTAINER_KEY_UP
 */
[Event(name = 'onContainerKeyUp', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires when there is a mousedown on the container
 * @eventType ext.panel.events.TablePanel_eEvent.CONTAINER_MOUSE_DOWN
 */
[Event(name = 'onContainerMouseDown', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires when you move the mouse out of the container.
 * @eventType ext.panel.events.TablePanel_eEvent.CONTAINER_MOUSE_OUT
 */
[Event(name = 'onContainerMouseOut', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires when you move the mouse over the container.
 * @eventType ext.panel.events.TablePanel_eEvent.CONTAINER_MOUSE_OVER
 */
[Event(name = 'onContainerMouseOver', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fires when there is a mouseup on the container
 * @eventType ext.panel.events.TablePanel_eEvent.CONTAINER_MOUSE_UP
 */
[Event(name = 'onContainerMouseUp', type = 'ext.panel.events.TablePanel_eEvent')]
/**
 * Fired after a record is deselected
 * @eventType ext.panel.events.TablePanel_record_indexEvent.DESELECT
 */
[Event(name = 'onDeselect', type = 'ext.panel.events.TablePanel_record_indexEvent')]
/**
 * Fired whenever the filter set changes.
 * @eventType ext.panel.events.TablePanel_store_filtersEvent.FILTER_CHANGE
 */
[Event(name = 'onFilterChange', type = 'ext.panel.events.TablePanel_store_filtersEvent')]
/**
 * Fired whenever the grouping in the grid changes.
 * @eventType ext.panel.events.TablePanel_store_grouperEvent.GROUP_CHANGE
 */
[Event(name = 'onGroupChange', type = 'ext.panel.events.TablePanel_store_grouperEvent')]
/**
 * @eventType ext.panel.events.TablePanel_ct_column_e_tEvent.HEADER_CLICK
 */
[Event(name = 'onHeaderClick', type = 'ext.panel.events.TablePanel_ct_column_e_tEvent')]
/**
 * @eventType ext.panel.events.TablePanel_ct_column_e_tEvent.HEADER_CONTEXT_MENU
 */
[Event(name = 'onHeaderContextMenu', type = 'ext.panel.events.TablePanel_ct_column_e_tEvent')]
/**
 * Fired immediately after the column header menu is created.
 * @eventType ext.panel.events.TablePanel_menu_headerCtEvent.HEADER_MENU_CREATE
 */
[Event(name = 'onHeaderMenuCreate', type = 'ext.panel.events.TablePanel_menu_headerCtEvent')]
/**
 * @eventType ext.panel.events.TablePanel_ct_column_e_tEvent.HEADER_TRIGGER_CLICK
 */
[Event(name = 'onHeaderTriggerClick', type = 'ext.panel.events.TablePanel_ct_column_e_tEvent')]
/**
 * Fires when an item is clicked.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_CLICK
 */
[Event(name = 'onItemClick', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires when an item is right clicked.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_CONTEXT_MENU
 */
[Event(name = 'onItemContextMenu', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires when an item is double clicked.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_DBLCLICK
 */
[Event(name = 'onItemDblclick', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires when a key is pressed down while an item is currently selected.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_KEY_DOWN
 */
[Event(name = 'onItemKeyDown', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires when a key is pressed while an item is currently selected.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_KEYPRESS
 */
[Event(name = 'onItemKeypress', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires when a key is released while an item is currently selected.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_KEY_UP
 */
[Event(name = 'onItemKeyUp', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires on a longpress event on an item.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_LONG_PRESS
 */
[Event(name = 'onItemLongPress', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires when there is a mouse down on an item
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_MOUSE_DOWN
 */
[Event(name = 'onItemMouseDown', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires when the mouse enters an item.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_MOUSE_ENTER
 */
[Event(name = 'onItemMouseEnter', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires when the mouse leaves an item.
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_MOUSE_LEAVE
 */
[Event(name = 'onItemMouseLeave', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires when there is a mouse up on an item
 * @eventType ext.panel.events.TablePanel_record_item_index_eEvent.ITEM_MOUSE_UP
 */
[Event(name = 'onItemMouseUp', type = 'ext.panel.events.TablePanel_record_item_index_eEvent')]
/**
 * Fires whenever the store reads data from a remote data source.
 * @eventType ext.panel.events.TablePanel_records_successful_operationEvent.LOAD
 */
[Event(name = 'onLoad', type = 'ext.panel.events.TablePanel_records_successful_operationEvent')]
/**
 * Fires when a column is locked.
 * @eventType ext.panel.events.TablePanel_columnEvent.LOCK_COLUMN
 */
[Event(name = 'onLockColumn', type = 'ext.panel.events.TablePanel_columnEvent')]
/**
 * Fires when the configured (or <strong>reconfigured</strong>) column set is split into two depending on the <a href="#!/api/Ext.grid.column.Column-cfg-locked" rel="Ext.grid.column.Column-cfg-locked" class="docClass">locked</a> flag.
 * @eventType ext.panel.events.TablePanel_lockedColumns_normalColumnsEvent.PROCESS_COLUMNS
 */
[Event(name = 'onProcessColumns', type = 'ext.panel.events.TablePanel_lockedColumns_normalColumnsEvent')]
/**
 * Fires when a row body element is clicked
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.ROW_BODY_CLICK
 */
[Event(name = 'onRowBodyClick', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires when a row body element is right clicked
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.ROW_BODY_CONTEXT_MENU
 */
[Event(name = 'onRowBodyContextMenu', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires when a row body element is double clicked
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.ROW_BODY_DBLCLICK
 */
[Event(name = 'onRowBodyDblclick', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires when a key is pressed down while a row body element is currently selected
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.ROW_BODY_KEY_DOWN
 */
[Event(name = 'onRowBodyKeyDown', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires when a key is pressed while a row body element is currently selected.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.ROW_BODY_KEYPRESS
 */
[Event(name = 'onRowBodyKeypress', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires when a key is released while a row body element is currently selected
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.ROW_BODY_KEY_UP
 */
[Event(name = 'onRowBodyKeyUp', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires on a row body element longpress event
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.ROW_BODY_LONG_PRESS
 */
[Event(name = 'onRowBodyLongPress', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires when there is a mouse down on a row body element
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.ROW_BODY_MOUSE_DOWN
 */
[Event(name = 'onRowBodyMouseDown', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fires when there is a mouse up on a row body element
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.panel.events.TablePanel_view_rowBodyEl_eEvent.ROW_BODY_MOUSE_UP
 */
[Event(name = 'onRowBodyMouseUp', type = 'ext.panel.events.TablePanel_view_rowBodyEl_eEvent')]
/**
 * Fired when table cell is clicked.
 * @eventType ext.panel.events.TablePanel_record_tr_rowIndex_eEvent.ROW_CLICK
 */
[Event(name = 'onRowClick', type = 'ext.panel.events.TablePanel_record_tr_rowIndex_eEvent')]
/**
 * Fired when table cell is right clicked.
 * @eventType ext.panel.events.TablePanel_record_tr_rowIndex_eEvent.ROW_CONTEXT_MENU
 */
[Event(name = 'onRowContextMenu', type = 'ext.panel.events.TablePanel_record_tr_rowIndex_eEvent')]
/**
 * Fired when table cell is double clicked.
 * @eventType ext.panel.events.TablePanel_record_tr_rowIndex_eEvent.ROW_DBLCLICK
 */
[Event(name = 'onRowDblclick', type = 'ext.panel.events.TablePanel_record_tr_rowIndex_eEvent')]
/**
 * Fired when the keydown event is captured on the cell.
 * @eventType ext.panel.events.TablePanel_record_tr_rowIndex_eEvent.ROW_KEY_DOWN
 */
[Event(name = 'onRowKeyDown', type = 'ext.panel.events.TablePanel_record_tr_rowIndex_eEvent')]
/**
 * Fired when the mousedown event is captured on the cell.
 * @eventType ext.panel.events.TablePanel_record_tr_rowIndex_eEvent.ROW_MOUSE_DOWN
 */
[Event(name = 'onRowMouseDown', type = 'ext.panel.events.TablePanel_record_tr_rowIndex_eEvent')]
/**
 * Fired when the mouseup event is captured on the cell.
 * @eventType ext.panel.events.TablePanel_record_tr_rowIndex_eEvent.ROW_MOUSE_UP
 */
[Event(name = 'onRowMouseUp', type = 'ext.panel.events.TablePanel_record_tr_rowIndex_eEvent')]
/**
 * Fired after a record is selected
 * @eventType ext.panel.events.TablePanel_record_indexEvent.SELECT
 */
[Event(name = 'onSelect', type = 'ext.panel.events.TablePanel_record_indexEvent')]
/**
 * Fired after a selection change has occurred
 * @eventType ext.panel.events.TablePanel_selectedEvent.SELECTION_CHANGE
 */
[Event(name = 'onSelectionChange', type = 'ext.panel.events.TablePanel_selectedEvent')]
/**
 * .
 * An event fired when an extension block is dragged to
 * encompass a new range.  Only fired when the SpreadsheetSelectionModel is used and
 * configured with the
 * <a href="#!/api/Ext.grid.selection.SpreadsheetModel-cfg-extensible" rel="Ext.grid.selection.SpreadsheetModel-cfg-extensible" class="docClass">extensible</a> config.
 * @eventType ext.panel.events.TablePanel_An_extensionEvent.SELECTION_EXTENDER_DRAG
 */
[Event(name = 'onSelectionExtenderDrag', type = 'ext.panel.events.TablePanel_An_extensionEvent')]
/**
 * @eventType ext.panel.events.TablePanel_ct_column_directionEvent.SORT_CHANGE
 */
[Event(name = 'onSortChange', type = 'ext.panel.events.TablePanel_ct_column_directionEvent')]
/**
 * Fires when a column is unlocked.
 * @eventType ext.panel.events.TablePanel_columnEvent.UNLOCK_COLUMN
 */
[Event(name = 'onUnlockColumn', type = 'ext.panel.events.TablePanel_columnEvent')]
/**
 * Fires when the grid view is available (use this for selecting a default row).
 * @eventType ext.panel.events.TablePanelEvent.VIEW_READY
 */
[Event(name = 'onViewReady', type = 'ext.panel.events.TablePanelEvent')]
/**
 * This class is the base class for both <a href="#!/api/Ext.tree.Panel" rel="Ext.tree.Panel" class="docClass">TreePanel</a> and
 * <a href="#!/api/Ext.grid.Panel" rel="Ext.grid.Panel" class="docClass">GridPanel</a>.
 *
 * <p>TablePanel aggregates:</p>
 *
 * <ul>
 * <li>a Selection Model</li>
 * <li>a View</li>
 * <li>a Store</li>
 * <li><a href="#!/api/Ext.grid.header.Container" rel="Ext.grid.header.Container" class="docClass">Ext.grid.header.Container</a></li>
 * </ul>
 */
public class TablePanel extends ext.panel.Panel implements ext.grid.locking.ILockable {
  /**
   * @param config @inheritDoc
   */
  public function TablePanel(config:ext.panel.TablePanel = null) {
    super();
  }

  [ExtConfig]
  /**
   * An array of events that, when fired, should trigger this object to
   * save its state. Defaults to none. <code>stateEvents</code> may be any type
   * of event supported by this object, including browser or custom events
   * (e.g., <code>['click', 'customerchange']</code>).
   *
   * <p>See <code><a href="#!/api/Ext.panel.Table-cfg-stateful" rel="Ext.panel.Table-cfg-stateful" class="docClass">stateful</a></code> for an explanation of saving and
   * restoring object state.</p>
   */
  override public native function get stateEvents():Array;

  [ExtConfig]
  /**
   * @private
   */
  override public native function set stateEvents(value:Array):void;

  /**
   * An array of objects which register themselves with a grid panel using
   * <a href="#!/api/Ext.panel.Table-method-registerActionable" rel="Ext.panel.Table-method-registerActionable" class="docClass">registerActionable</a> which are consulted upon entry into actionable mode.
   *
   * <p>These must implement the following methods:</p>
   *
   * <ul>
   * <li> activateCell Called when actionable mode is requested upon a cell. A <a href="#!/api/Ext.grid.CellContext" rel="Ext.grid.CellContext" class="docClass">CellContext</a>
   * object is passed. If that cell is actionable by the terms of the callee, the callee should return <code>true</code> if it
   * ascertains that the cell is actionable, and that it now contains focusable elements which may be tabbed to.</li>
   * <li> activateRow Called when the user enters actionable mode in a row. The row DOM is passed. Actionables
   * should take any action they need to prime the row for cell activation which happens as users TAB from cell to cell.</li>
   * </ul>
   */
  public native function get actionables():Array;

  /**
   * True to indicate that a view has been injected into the panel.
   * @default false
   */
  public native function get hasView():Boolean;

  /**
   * @private
   */
  public native function set hasView(value:Boolean):void;

  /**
   * If you are writing a grid plugin or a {<a href="#!/api/Ext.grid.feature.Feature" rel="Ext.grid.feature.Feature" class="docClass">Ext.grid.feature.Feature</a> Feature} which creates a column-based structure which
   * needs a view refresh when columns are moved, then set this property in the grid.
   *
   * <p>An example is the built in <a href="#!/api/Ext.grid.feature.AbstractSummary" rel="Ext.grid.feature.AbstractSummary" class="docClass">Summary</a> Feature. This creates summary rows, and the
   * summary columns must be in the same order as the data columns. This plugin sets the <code>optimizedColumnMove</code> to `false.</p>
   */
  public native function get optimizedColumnMove():Boolean;

  /**
   * @private
   */
  public native function set optimizedColumnMove(value:Boolean):void;

  [ExtConfig]
  /**
   * True to allow deselecting a record. This config is forwarded to <a href="#!/api/Ext.selection.Model-cfg-allowDeselect" rel="Ext.selection.Model-cfg-allowDeselect" class="docClass">Ext.selection.Model.allowDeselect</a>.
   * @default false
   */
  public native function get allowDeselect():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set allowDeselect(value:Boolean):void;

  [ExtConfig]
  /**
   * Use <code>true</code> to load the store as soon as this component is fully constructed. It is
   * best to initiate the store load this way to allow this component and potentially
   * its plugins (such as <code><a href="#!/api/Ext.grid.filters.Filters" rel="Ext.grid.filters.Filters" class="docClass">Ext.grid.filters.Filters</a></code>) to be ready to load.
   * @default false
   */
  public native function get autoLoad():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set autoLoad(value:Boolean):void;

  [ExtConfig]
  /**
   * Buffered rendering is enabled by default.
   *
   * <p>Configure as <code>false</code> to disable buffered rendering. See <a href="#!/api/Ext.grid.plugin.BufferedRenderer" rel="Ext.grid.plugin.BufferedRenderer" class="docClass">Ext.grid.plugin.BufferedRenderer</a>.</p>
   * @default true
   * @since 5.0.0
   */
  public native function get bufferedRenderer():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set bufferedRenderer(value:Boolean):void;

  [ExtConfig]
  /**
   * Adds column line styling
   */
  public native function get columnLines():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set columnLines(value:Boolean):void;

  [ExtConfig]
  /**
   * An array of <a href="#!/api/Ext.grid.column.Column" rel="Ext.grid.column.Column" class="docClass">column</a> definition objects which define all columns that appear in this
   * grid. Each column definition provides the header text for the column, and a definition of where the data for that
   * column comes from.
   *
   * <p>This can also be a configuration object for a <a href="#!/api/Ext.grid.header.Container" rel="Ext.grid.header.Container" class="docClass">HeaderContainer</a> which may override
   * certain default configurations if necessary. For example, the special layout may be overridden to use a simpler
   * layout, or one can set default values shared by all columns:</p>
   *
   * <pre><code>columns: {
   *     items: [
   *         {
   *             text: "Column A",
   *             dataIndex: "field_A"
   *         },{
   *             text: "Column B",
   *             dataIndex: "field_B"
   *         },
   *         ...
   *     ],
   *     defaults: {
   *         flex: 1
   *     }
   * }
   * </code></pre>
   * @see #getColumns()
   */
  public native function get columns():Array;

  [ExtConfig]
  /**
   * @private
   */
  public native function set columns(value:Array):void;

  [ExtConfig]
  /**
   * Configure as <code>true</code> to enable deferred row rendering.
   *
   * <p>This allows the View to execute a refresh quickly, with the update of the row structure deferred so
   * that layouts with GridPanels appear, and lay out more quickly.</p>
   * @default false
   */
  public native function get deferRowRender():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set deferRowRender(value:Boolean):void;

  [ExtConfig]
  /**
   * True to disable selection model.
   * @default false
   */
  public native function get disableSelection():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set disableSelection(value:Boolean):void;

  [ExtConfig]
  /**
   * Default text (HTML tags are accepted) to display in the
   * Panel body when the Store is empty. When specified, and the Store is empty, the
   * text will be rendered inside a DIV with the CSS class "x-grid-empty". The emptyText
   * will not display until the first load of the associated store by default. If you
   * want the text to be displayed prior to the first store load use the
   * <a href="#!/api/Ext.view.Table-cfg-deferEmptyText" rel="Ext.view.Table-cfg-deferEmptyText" class="docClass">deferEmptyText</a> config in the <a href="#!/api/Ext.panel.Table-cfg-viewConfig" rel="Ext.panel.Table-cfg-viewConfig" class="docClass">viewConfig</a> config.
   */
  public native function get emptyText():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set emptyText(value:String):void;

  [ExtConfig]
  /**
   * False to disable column hiding within this grid.
   * @default true
   */
  public native function get enableColumnHide():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set enableColumnHide(value:Boolean):void;

  [ExtConfig]
  /**
   * False to disable column dragging within this grid.
   * @default true
   */
  public native function get enableColumnMove():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set enableColumnMove(value:Boolean):void;

  [ExtConfig]
  /**
   * False to disable column resizing within this grid.
   * @default true
   */
  public native function get enableColumnResize():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set enableColumnResize(value:Boolean):void;

  [ExtConfig]
  /**
   * Configure as <code>true</code> to enable locking support for this grid. Alternatively, locking will also be automatically
   * enabled if any of the columns in the <a href="#!/api/Ext.panel.Table-cfg-columns" rel="Ext.panel.Table-cfg-columns" class="docClass">columns</a> configuration contain a <a href="#!/api/Ext.grid.column.Column-cfg-locked" rel="Ext.grid.column.Column-cfg-locked" class="docClass">locked</a> config option.
   *
   * <p>A locking grid is processed in a special way. The configuration options are cloned and <em>two</em> grids are created to be the locked (left) side
   * and the normal (right) side. This Panel becomes merely a <a href="#!/api/Ext.container.Container" rel="Ext.container.Container" class="docClass">container</a> which arranges both in an <a href="#!/api/Ext.layout.container.HBox" rel="Ext.layout.container.HBox" class="docClass">HBox</a> layout.</p>
   *
   * <p><a href="#!/api/Ext.panel.Table-cfg-plugins" rel="Ext.panel.Table-cfg-plugins" class="docClass">Plugins</a> may be targeted at either locked, or unlocked grid, or, both, in which case the plugin is cloned and used on both sides.</p>
   *
   * <p>Plugins may also be targeted at the containing locking Panel.</p>
   *
   * <p>This is configured by specifying a <code>lockableScope</code> property in your plugin which may have the following values:</p>
   *
   * <ul>
   * <li><code>"both"</code> (the default) - The plugin is added to both grids</li>
   * <li><code>"top"</code> - The plugin is added to the containing Panel</li>
   * <li><code>"locked"</code> - The plugin is added to the locked (left) grid</li>
   * <li><code>"normal"</code> - The plugin is added to the normal (right) grid</li>
   * </ul>
   *
   *
   * <p>If <code>both</code> is specified, then each copy of the plugin gains a property <code>lockingPartner</code> which references its sibling on the other side so that they
   * can synchronize operations is necessary.</p>
   *
   * <p><a href="#!/api/Ext.panel.Table-cfg-features" rel="Ext.panel.Table-cfg-features" class="docClass">Features</a> may also be configured with <code>lockableScope</code> and may target the locked grid, the normal grid or both grids. Features
   * also get a <code>lockingPartner</code> reference injected.</p>
   * @default false
   */
  public native function get enableLocking():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set enableLocking(value:Boolean):void;

  [ExtConfig]
  [ArrayElementType("ext.grid.feature.IFeature")]
  /**
   * An array of grid Features to be added to this grid.
   *
   * <p>Features config behaves much like <a href="#!/api/Ext.panel.Table-cfg-plugins" rel="Ext.panel.Table-cfg-plugins" class="docClass">plugins</a>.
   * A feature can be added by either directly referencing the instance:</p>
   *
   * <pre><code>features: [<a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.grid.feature.GroupingSummary" rel="Ext.grid.feature.GroupingSummary" class="docClass">Ext.grid.feature.GroupingSummary</a>', {groupHeaderTpl: 'Subject: {name}'})],
   * </code></pre>
   *
   * <p>By using config object with ftype:</p>
   *
   * <pre><code>features: [{ftype: 'groupingsummary', groupHeaderTpl: 'Subject: {name}'}],
   * </code></pre>
   *
   * <p>Or with just a ftype:</p>
   *
   * <pre><code>features: ['grouping', 'groupingsummary'],
   * </code></pre>
   *
   * <p>See <a href="#!/api/Ext.enums.Feature" rel="Ext.enums.Feature" class="docClass">Ext.enums.Feature</a> for list of all ftypes.</p>
   */
  public native function get features():Array;

  [ExtConfig]
  /**
   * @private
   */
  public native function set features(value:Array):void;

  [ExtConfig]
  /**
   * True to force the columns to fit into the available width. Headers are first sized according to configuration,
   * whether that be a specific width, or flex. Then they are all proportionally changed in width so that the entire
   * content width is used. For more accurate control, it is more optimal to specify a flex setting on the columns
   * that are to be stretched &amp; explicit widths on columns that are not.
   */
  public native function get forceFit():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set forceFit(value:Boolean):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * To show no borders around grid headers, configure this as <code>false</code>.
   * @default `true`
   * @see #getHeaderBorders()
   * @see #setHeaderBorders()
   */
  public native function get headerBorders():Boolean;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set headerBorders(value:Boolean):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * By default, visibility of headers is managed automatically based upon
   * whether there is textual content to display.
   * This configuration is only necessary if you want to disable automatic
   * header visibility management.
   *
   * <p>If no columns have a text config
   * (for example in the case of a <a href="#!/api/Ext.tree.Panel" rel="Ext.tree.Panel" class="docClass">TreePanel</a> with no
   * columns specified), and no columns have <a href="#!/api/Ext.grid.column.Column-cfg-columns" rel="Ext.grid.column.Column-cfg-columns" class="docClass">child columns</a>
   * then headers are hidden.</p>
   *
   * <p>If this status changes - if the column set ever goes from none having
   * text, to one having text or vice versa), then the visibility of headers
   * will be recalculated.</p>
   *
   * <p>Configure as <code>true</code> to hide column headers. Configure as <code>false</code> to show
   * column headers even if none of them have text.</p>
   * @see #getHideHeaders()
   * @see #setHideHeaders()
   */
  public native function get hideHeaders():Boolean;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set hideHeaders(value:Boolean):void;

  [ExtConfig]
  /**
   * TableViews are buffer rendered in 5.x and above which means that only the visible subset of data rows
   * are rendered into the DOM. These are removed and added as scrolling demands.
   *
   * <p>This configures the number of extra rows to render on the leading side of scrolling
   * <strong>outside the <a href="#!/api/Ext.panel.Table-cfg-numFromEdge" rel="Ext.panel.Table-cfg-numFromEdge" class="docClass">numFromEdge</a></strong> buffer as scrolling proceeds.</p>
   * @default 20
   */
  public native function get leadingBufferZone():Number;

  [ExtConfig]
  /**
   * @private
   */
  public native function set leadingBufferZone(value:Number):void;

  [ExtConfig]
  /**
   * Any special configuration options for the locked part of the grid
   */
  public native function get lockedGridConfig():Object;

  [ExtConfig]
  /**
   * @private
   */
  public native function set lockedGridConfig(value:Object):void;

  [ExtConfig]
  /**
   * A view configuration to be applied to the
   * locked side of the grid. Any conflicting configurations between lockedViewConfig
   * and viewConfig will be overwritten by the lockedViewConfig.
   */
  public native function get lockedViewConfig():Object;

  [ExtConfig]
  /**
   * @private
   */
  public native function set lockedViewConfig(value:Object):void;

  [ExtConfig]
  /**
   * Configure as <code>true</code> to have columns remember their sorted state after other columns have been clicked upon to sort.
   *
   * <p>As subsequent columns are clicked upon, they become the new primary sort key.</p>
   *
   * <p>The maximum number of sorters allowed in a Store is configurable via its underlying data collection. See <a href="#!/api/Ext.util.Collection-cfg-multiSortLimit" rel="Ext.util.Collection-cfg-multiSortLimit" class="docClass">Ext.util.Collection.multiSortLimit</a></p>
   * @default false
   */
  public native function get multiColumnSort():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set multiColumnSort(value:Boolean):void;

  [Deprecated(replacement = "mode", since = "4.1.1")]
  [ExtConfig]
  /**
   * True to enable 'MULTI' selection mode on selection model.
   * @default false
   */
  public native function get multiSelect():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set multiSelect(value:Boolean):void;

  [ExtConfig]
  /**
   * Any special configuration options for the normal part of the grid
   */
  public native function get normalGridConfig():Object;

  [ExtConfig]
  /**
   * @private
   */
  public native function set normalGridConfig(value:Object):void;

  [ExtConfig]
  /**
   * A view configuration to be applied to the
   * normal/unlocked side of the grid. Any conflicting configurations between normalViewConfig
   * and viewConfig will be overwritten by the normalViewConfig.
   */
  public native function get normalViewConfig():Object;

  [ExtConfig]
  /**
   * @private
   */
  public native function set normalViewConfig(value:Object):void;

  [ExtConfig]
  /**
   * This configures the zone which causes new rows to be appended to the view. As soon as the edge
   * of the rendered grid is this number of rows from the edge of the viewport, the view is moved.
   * @default 2
   */
  public native function get numFromEdge():Number;

  [ExtConfig]
  /**
   * @private
   */
  public native function set numFromEdge(value:Number):void;

  [ExtConfig]
  /**
   * The focused cell, model or index. Typically used with <a href="#!/api/Ext.panel.Table-cfg-bind" rel="Ext.panel.Table-cfg-bind" class="docClass">binding</a>.
   *
   * <p>If bound to a record (such as a selection), the first cell will be focused.</p>
   */
  public native function get record():*;

  [ExtConfig]
  /**
   * @private
   */
  public native function set record(value:*):void;

  [ExtConfig]
  /**
   * Set this to true to <strong>always</strong> leave a scrollbar sized space at the end of the grid content when
   * fitting content into the width of the grid.
   *
   * <p>If the grid's record count fluctuates enough to hide and show the scrollbar regularly, this setting
   * avoids the multiple layouts associated with switching from scrollbar present to scrollbar not present.</p>
   * @default false
   */
  public native function get reserveScrollbar():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set reserveScrollbar(value:Boolean):void;

  [ExtConfig]
  /**
   * Adds row line styling
   * @default true
   */
  public native function get rowLines():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set rowLines(value:Boolean):void;

  [ExtConfig]
  /**
   * The type or a config object specifying the type of the ViewModel to instantiate when creating ViewModels for records
   * to which <a href="#!/api/Ext.grid.column.Widget" rel="Ext.grid.column.Widget" class="docClass">widgets in widget columns</a>, and widgets in a
   * <a href="#!/api/Ext.grid.plugin.RowWidget" rel="Ext.grid.plugin.RowWidget" class="docClass">RowWidget</a> row bind.
   */
  public native function get rowViewModel():*;

  [ExtConfig]
  /**
   * @private
   */
  public native function set rowViewModel(value:*):void;

  [Deprecated(replacement = "scrollable", since = "5.1.0")]
  [ExtConfig]
  /**
   * Scrollers configuration. Valid values are 'both', 'horizontal' or 'vertical'.
   * True implies 'both'. False implies 'none'.
   */
  public native function get scroll():*;

  [ExtConfig]
  /**
   * @private
   */
  public native function set scroll(value:*):void;

  [ExtConfig]
  /**
   * True to constrain column dragging so that a column cannot be dragged in or out of it's
   * current group. Only relevant while <a href="#!/api/Ext.panel.Table-cfg-enableColumnMove" rel="Ext.panel.Table-cfg-enableColumnMove" class="docClass">enableColumnMove</a> is enabled.
   * @default false
   */
  public native function get sealedColumns():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set sealedColumns(value:Boolean):void;

  [ExtConfig]
  /**
   * A <a href="#!/api/Ext.selection.Model" rel="Ext.selection.Model" class="docClass">selection model</a> instance or config object, or the selection model class's alias string.
   *
   * <p>In latter case its <code>type</code> property determines to which type of selection model this config is applied.</p>
   * @default rowmodel
   */
  public native function get selModel():Object;

  [ExtConfig]
  /**
   * @private
   */
  public native function set selModel(value:*):void;

  [Deprecated(replacement = "selModel", since = "5.1.0")]
  [ExtConfig]
  /**
   * An xtype of selection model to use. This is used to create selection model if just
   * a config object or nothing at all given in <a href="#!/api/Ext.panel.Table-cfg-selModel" rel="Ext.panel.Table-cfg-selModel" class="docClass">selModel</a> config.
   */
  public native function get selType():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set selType(value:String):void;

  [ExtConfig]
  /**
   * The selected model. Typically used with <a href="#!/api/Ext.panel.Table-cfg-bind" rel="Ext.panel.Table-cfg-bind" class="docClass">binding</a>.
   * @see #setSelection()
   */
  public native function get selection():ext.data.Model;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set selection(value:ext.data.Model):void;

  [Deprecated(replacement = "mode", since = "4.1.1")]
  [ExtConfig]
  /**
   * True to enable 'SIMPLE' selection mode on selection model.
   * @default false
   */
  public native function get simpleSelect():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set simpleSelect(value:Boolean):void;

  [ExtConfig]
  /**
   * False to disable column sorting via clicking the header and via the Sorting menu items.
   * @default true
   */
  public native function get sortableColumns():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set sortableColumns(value:Boolean):void;

  [ExtConfig]
  /**
   * Configure as <code>true</code> to place a resizing <a href="#!/api/Ext.resizer.Splitter" rel="Ext.resizer.Splitter" class="docClass">splitter</a> between the locked
   * and unlocked columns. May also be a configuration object for the Splitter.
   * @default false
   */
  public native function get split():*;

  [ExtConfig]
  /**
   * @private
   */
  public native function set split(value:*):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The data source to which the grid / tree is bound. Acceptable values for this
   * property are:
   *
   * <ul>
   * <li><strong>any <a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Store</a> class / subclass</strong></li>
   * <li><strong>an <a href="#!/api/Ext.data.Store-cfg-storeId" rel="Ext.data.Store-cfg-storeId" class="docClass">ID of a store</a></strong></li>
   * <li><strong>a <a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Store</a> config object</strong>.  When passing a config you can
   * specify the store type by alias.  Passing a config object with a store type will
   * dynamically create a new store of that type when the grid / tree is instantiated.</li>
   * </ul>
   *
   *
   * <p>For example:</p>
   *
   * <pre><code><a href="#!/api/Ext-method-define" rel="Ext-method-define" class="docClass">Ext.define</a>('MyApp.store.Customers', {
   *     extend: '<a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a>',
   *     alias: 'store.customerstore',
   *     fields: ['name']
   * });
   *
   * <a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>({
   *     xtype: 'gridpanel',
   *     renderTo: document.body,
   *     store: {
   *         type: 'customerstore',
   *         data: [{
   *             name: 'Foo'
   *         }]
   *     },
   *     columns: [{
   *         text: 'Name',
   *         dataIndex: 'name'
   *     }]
   * });
   * </code></pre>
   * @see #getStore()
   * @see #setStore()
   */
  public native function get store():*;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set store(value:*):void;

  [ExtConfig]
  /**
   * The xtype of the subgrid to specify. If this is
   * not specified lockable will determine the subgrid xtype to create by the
   * following rule. Use the superclasses xtype if the superclass is NOT
   * tablepanel, otherwise use the xtype itself.
   */
  public native function get subGridXType():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set subGridXType(value:String):void;

  [ExtConfig]
  /**
   * Synchronize rowHeight between the normal and
   * locked grid view. This is turned on by default. If your grid is guaranteed
   * to have rows of all the same height, you should set this to false to
   * optimize performance.
   * @default true
   */
  public native function get syncRowHeight():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set syncRowHeight(value:Boolean):void;

  [ExtConfig]
  /**
   * TableViews are buffer rendered in 5.x and above which means that only the visible subset of data rows
   * are rendered into the DOM. These are removed and added as scrolling demands.
   *
   * <p>This configures the number of extra rows to render on the trailing side of scrolling
   * <strong>outside the <a href="#!/api/Ext.panel.Table-cfg-numFromEdge" rel="Ext.panel.Table-cfg-numFromEdge" class="docClass">numFromEdge</a></strong> buffer as scrolling proceeds.</p>
   * @default 10
   */
  public native function get trailingBufferZone():Number;

  [ExtConfig]
  /**
   * @private
   */
  public native function set trailingBufferZone(value:Number):void;

  [Deprecated(replacement = "variableRowHeight", since = "5.0.0")]
  [ExtConfig]
  /**
   * @default false
   */
  public native function get variableRowHeight():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set variableRowHeight(value:Boolean):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The <a href="#!/api/Ext.view.Table" rel="Ext.view.Table" class="docClass">Ext.view.Table</a> used by the grid. Use <a href="#!/api/Ext.panel.Table-cfg-viewConfig" rel="Ext.panel.Table-cfg-viewConfig" class="docClass">viewConfig</a> to just supply some config options to
   * view (instead of creating an entire View instance).
   * @see #getView()
   */
  public native function get view():ext.view.TableView;

  [ExtConfig("viewConfig")]
  /**
   * @private
   */
  public native function set view(value:ext.view.TableView):void;

  [ExtConfig]
  /**
   * A config object that will be applied to the grid's UI view. Any of the config options available for
   * <a href="#!/api/Ext.view.Table" rel="Ext.view.Table" class="docClass">Ext.view.Table</a> can be specified here. This option is ignored if <a href="#!/api/Ext.panel.Table-cfg-view" rel="Ext.panel.Table-cfg-view" class="docClass">view</a> is specified.
   */
  public native function get viewConfig():ext.view.TableView;

  [ExtConfig]
  /**
   * @private
   */
  public native function set viewConfig(value:ext.view.TableView):void;

  [ExtConfig]
  /**
   * An xtype of view to use. This is automatically set to 'tableview' by <a href="#!/api/Ext.grid.Panel" rel="Ext.grid.Panel" class="docClass">Grid</a>
   * and to 'treeview' by <a href="#!/api/Ext.tree.Panel" rel="Ext.tree.Panel" class="docClass">Tree</a>.
   */
  public native function get viewType():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set viewType(value:String):void;

  /**
   * @param scroll True to allow the Component to auto scroll.
   */
  override public native function setAutoScroll(scroll:Boolean):ext.Component;

  /**
   * Disables interaction with, and masks this grid's column headers.
   */
  public native function disableColumnHeaders():void;

  /**
   * Enables interaction with, and unmasks this grid's column headers after a call to {<a href="#!/api/Ext.panel.Table-method-disableColumnHeaders" rel="Ext.panel.Table-method-disableColumnHeaders" class="docClass">disableColumnHeaders</a>}.
   */
  public native function enableColumnHeaders():void;

  /**
   * Scrolls the specified record into view.
   * @param record The record, record id,  or the zero-based position in the dataset to scroll to.
   * @param options An object containing options to modify the operation.
   * @param {Boolean} [options.animate] Pass <code>true</code> to animate the row into view.
   * @param {Boolean} [options.highlight] Pass <code>true</code> to highlight the row with a glow animation when it is in view.
   * @param {Boolean} [options.select] Pass as <code>true</code> to select the specified row.
   * @param {Boolean} [options.focus] Pass as <code>true</code> to focus the specified row.
   * @param {Function} [options.callback] A function to execute when the record is in view. This may be necessary if the
   *                          first parameter is a record index and the view is backed by a <a href="#!/api/Ext.data.BufferedStore" rel="Ext.data.BufferedStore" class="docClass">buffered store</a>
   *                          which does not contain that record.
   * @param {Boolean} options.callback.success <code>true</code> if acquiring the record's view node was successful.
   * @param {ext.data.Model} options.callback.record If successful, the target record.
   * @param {js.HTMLElement} options.callback.node If successful, the record's view node.
   * @param {Object} [options.scope] The scope (<code>this</code> reference) in which the callback function is executed.
   */
  public native function ensureVisible(record:*, options:Object = null):void;

  /**
   * Returns an array of all columns which exist in the grid's View, visible or not.
   * This goes down to the leaf column header level, and does not return <strong>grouped</strong>
   * headers which contain sub headers.
   *
   * <p>It includes hidden headers even though they are not rendered. This is for
   * collection of menu items for the column hide/show menu.</p>
   *
   * <p>Headers which have a hidden ancestor have a <code>hiddenAncestor: true</code> property
   * injected so that descendants are known to be hidden without interrogating that
   * header's ownerCt axis for a hidden ancestor.</p>
   *
   * <p>See also <a href="#!/api/Ext.grid.header.Container-method-getVisibleGridColumns" rel="Ext.grid.header.Container-method-getVisibleGridColumns" class="docClass">Ext.grid.header.Container.getVisibleGridColumns</a></p>
   * @return columns An array of columns.  Returns an
   * empty array if no columns are found.
   */
  public native function getColumns():Array;

  /**
   * Returns the value of <a href="#!/api/Ext.panel.Table-cfg-headerBorders" rel="Ext.panel.Table-cfg-headerBorders" class="docClass">headerBorders</a>.
   */
  public native function getHeaderBorders():Boolean;

  /**
   * Gets the <a href="#!/api/Ext.grid.header.Container" rel="Ext.grid.header.Container" class="docClass">headercontainer</a> for this grid / tree.
   * @return headercontainer
   * <p><strong>Note:</strong> While a locked grid / tree will return an instance of
   * <a href="#!/api/Ext.grid.locking.HeaderContainer" rel="Ext.grid.locking.HeaderContainer" class="docClass">Ext.grid.locking.HeaderContainer</a> you will code to the
   * <a href="#!/api/Ext.grid.header.Container" rel="Ext.grid.header.Container" class="docClass">Ext.grid.header.Container</a> API.</p>
   */
  public native function getHeaderContainer():ext.grid.header.HeaderContainer;

  /**
   * Returns the value of <a href="#!/api/Ext.panel.Table-cfg-hideHeaders" rel="Ext.panel.Table-cfg-hideHeaders" class="docClass">hideHeaders</a>.
   */
  public native function getHideHeaders():Boolean;

  /**
   * Returns the grid's selection. See <code><a href="#!/api/Ext.selection.Model-method-getSelection" rel="Ext.selection.Model-method-getSelection" class="docClass">Ext.selection.Model.getSelection</a></code>.
   * @return The selected records
   */
  public native function getSelection():Array;

  /**
   * Returns the selection model being used by this grid's <a href="#!/api/Ext.view.Table" rel="Ext.view.Table" class="docClass">view</a>.
   * @return The selection model being used by this grid's <a href="#!/api/Ext.view.Table" rel="Ext.view.Table" class="docClass">view</a>.
   */
  public native function getSelectionModel():ext.selection.SelectionModel;

  /**
   * Returns the store associated with this Panel.
   * @return The store
   */
  public native function getStore():ext.data.Store;

  /**
   * Gets the view for this panel.
   */
  public native function getView():ext.view.TableView;

  /**
   * Returns an array of the <strong>visible</strong> columns in the grid. This goes down to the
   * lowest column header level, and does not return <strong>grouped</strong> headers which contain
   * sub headers.
   *
   * <p>See also <a href="#!/api/Ext.grid.header.Container-method-getGridColumns" rel="Ext.grid.header.Container-method-getGridColumns" class="docClass">Ext.grid.header.Container.getGridColumns</a></p>
   * @return columns An array of visible columns.  Returns
   * an empty array if no visible columns are found.
   */
  public native function getVisibleColumns():Array;

  /**
   * Reconfigures the grid or tree with a new store and/or columns. Stores and columns
   * may also be passed as params.
   *
   * <pre><code>grid.reconfigure(store, columns);
   * </code></pre>
   *
   * <p>Additionally, you can pass just a store or columns.</p>
   *
   * <pre><code>tree.reconfigure(store);
   * // or
   * grid.reconfigure(columns);
   * // or
   * tree.reconfigure(null, columns);
   * </code></pre>
   *
   * <p>If you're using locked columns, the <a href="#!/api/Ext.panel.Table-cfg-enableLocking" rel="Ext.panel.Table-cfg-enableLocking" class="docClass">enableLocking</a> config should be set
   * to <code>true</code> before the reconfigure method is executed.</p>
   * @param store The new store instance or store config. You can
   * pass <code>null</code> if no new store.
   * @param columns An array of column configs
   */
  public native function reconfigure(store:* = undefined, columns:Array = null):void;

  /**
   * @param actionable An object which has an interest in the implementation of actionable mode in
   * this grid.
   * <p>An actionable object may be a Plugin which upon activation injects tabbable elements or Components into
   * a grid row.</p>
   */
  public native function registerActionable(actionable:Object):void;

  /**
   * Sets the value of <a href="#!/api/Ext.panel.Table-cfg-headerBorders" rel="Ext.panel.Table-cfg-headerBorders" class="docClass">headerBorders</a>.
   * @param headerBorders The new value.
   */
  public native function setHeaderBorders(headerBorders:Boolean):void;

  /**
   * Sets the value of <a href="#!/api/Ext.panel.Table-cfg-hideHeaders" rel="Ext.panel.Table-cfg-hideHeaders" class="docClass">hideHeaders</a>.
   * @param hideHeaders The new value.
   */
  public native function setHideHeaders(hideHeaders:Boolean):void;

  /**
   * Sets the value of <a href="#!/api/Ext.panel.Table-cfg-selection" rel="Ext.panel.Table-cfg-selection" class="docClass">selection</a>.
   * @param selection The new value.
   */
  public native function setSelection(selection:ext.data.Model):void;

  /**
   * A convenience method that fires <a href="#!/api/Ext.panel.Table-method-reconfigure" rel="Ext.panel.Table-method-reconfigure" class="docClass">reconfigure</a> with the store param.  To set the store AND change columns,
   * use the <a href="#!/api/Ext.panel.Table-method-reconfigure" rel="Ext.panel.Table-method-reconfigure" class="docClass">reconfigure method</a>.
   * @param store The new store.
   */
  public native function setStore(store:ext.data.Store = null):void;

  /**
   * Synchronizes the row heights between the locked and non locked portion of the grid for each
   * row. If one row is smaller than the other, the height will be increased to match the larger one.
   */
  public native function syncRowHeights():void;
}
}