package ext.panel.events {
import ext.panel.Panel;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class PanelEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires before the user closes the panel. Return false from any listener to stop the close event being
   * fired
   * @see ext.panel.Panel
   * @eventType onBeforeClose
   */
  public static const BEFORE_CLOSE:String = "onBeforeClose";

  /**
   * "Fires when the user closes the panel.
   * @see ext.panel.Panel
   * @eventType onClose
   */
  public static const CLOSE:String = "onClose";

  /**
   * "Fires after this Panel has collapsed.
   * @see ext.panel.Panel
   * @eventType onCollapse
   */
  public static const COLLAPSE:String = "onCollapse";

  /**
   * "Fires after this Panel has expanded.
   * @see ext.panel.Panel
   * @eventType onExpand
   */
  public static const EXPAND:String = "onExpand";

  /**
   * "Fires after a collapsed Panel has been "floated" by clicking on
   * it's header. Only applicable when the Panel is an item in a
   * <a href="#!/api/Ext.layout.container.Border" rel="Ext.layout.container.Border" class="docClass">Border Layout</a>.
   * @see ext.panel.Panel
   * @eventType onFloat
   */
  public static const FLOAT:String = "onFloat";

  /**
   * "Fires after a "floated" Panel has returned to it's collapsed state
   * as a result of the mouse leaving the Panel. Only applicable when
   * the Panel is an item in a
   * <a href="#!/api/Ext.layout.container.Border" rel="Ext.layout.container.Border" class="docClass">Border Layout</a>.
   * @see ext.panel.Panel
   * @eventType onUnfloat
   */
  public static const UNFLOAT:String = "onUnfloat";

  public function PanelEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The Panel object
   */
  public native function get panel():ext.panel.Panel;
}
}