package ext.plugin {
import ext.mixin.Responsive;

[Uses("ext.mixin.Responsive")]
[Uses("ext.Base")]
[Native("Ext.plugin.Responsive", require)]
/**
 * This plugin can be added to component instances to process a <code>responsiveConfig</code>. For
 * example:
 *
 * <pre><code> <a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>({
 *      xtype: 'viewport',
 *      layout: 'border',
 *
 *      items: [{
 *          title: 'Some Title',
 *          plugins: 'responsive',
 *
 *          responsiveConfig: {
 *              'width &lt; 800': {
 *                  region: 'north'
 *              },
 *
 *              'width &gt;= 800': {
 *                  region: 'west'
 *              }
 *          }
 *      }]
 *  });
 * </code></pre>
 *
 * <p>For details see <code><a href="#!/api/Ext.mixin.Responsive-cfg-responsiveConfig" rel="Ext.mixin.Responsive-cfg-responsiveConfig" class="docClass">responsiveConfig</a></code>.</p>
 */
public class ResponsivePlugin extends ext.mixin.Responsive {
  /**
   * @param config @inheritDoc
   */
  public function ResponsivePlugin(config:ext.plugin.ResponsivePlugin = null) {
    super();
  }
}
}