package ext.selection {

[Uses("ext.selection.RowSelectionModel")]
[Uses("ext.selection.DataViewSelectionModel")]
[Uses("ext.selection.SelectionModel")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.util.StoreHolder")]
[Native("Ext.selection.TreeModel", require)]
/**
 * This selection model is created by default for <a href="#!/api/Ext.tree.Panel" rel="Ext.tree.Panel" class="docClass">Ext.tree.Panel</a>.
 *
 * <p>It implements a row selection model.</p>
 */
public class TreeSelectionModel extends ext.selection.RowSelectionModel {
  /**
   * @param config @inheritDoc
   */
  public function TreeSelectionModel(config:ext.selection.TreeSelectionModel = null) {
    super();
  }

  [ExtConfig]
  /**
   * <code>true</code> to select the row when clicking on the icon to collapse or expand
   * a tree node.
   * @default false
   * @since 5.1.0
   */
  public native function get selectOnExpanderClick():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set selectOnExpanderClick(value:Boolean):void;
}
}