package ext.sparkline {

[Uses("ext.sparkline.SparklineBase")]
[Uses("ext.Widget")]
[Uses("ext.mixin.Pluggable")]
[Uses("ext.Base")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.Evented")]
[Uses("ext.mixin.Observable")]
[Native("Ext.sparkline.Bullet", require)]
/**
 * Plots a bullet graph based upon the input <a href="#!/api/Ext.sparkline.Bullet-cfg-values" rel="Ext.sparkline.Bullet-cfg-values" class="docClass">values</a> array.
 *
 * <p>See <a href="http://en.wikipedia.org/wiki/Bullet_graph">Bullet graphs Wikipedia Page</a> for more information.</p>
 *
 * <p>See <a href="#!/api/Ext.sparkline.Base" rel="Ext.sparkline.Base" class="docClass">the base class</a> for a simple example.</p>
 */
public class SparklineBullet extends ext.sparkline.SparklineBase {
  /**
   * @param config @inheritDoc
   */
  public function SparklineBullet(config:ext.sparkline.SparklineBullet = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * Set this to a number to change the base start number.
   * @see #getBase()
   * @see #setBase()
   */
  public native function get base():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set base(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The color of the performance measure horizontal bar.
   * @default #33f
   * @see #getPerformanceColor()
   * @see #setPerformanceColor()
   */
  public native function get performanceColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set performanceColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * An array of colors to use for each qualitative range background color.
   * @default ['#d3dafe', '#a8b6ff', '#7f94ff']
   * @see #getRangeColors()
   * @see #setRangeColors()
   */
  public native function get rangeColors():Array;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set rangeColors(value:Array):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The colour of the vertical target marker.
   * @default #f33
   * @see #getTargetColor()
   * @see #setTargetColor()
   */
  public native function get targetColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set targetColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * Width of the target bar in pixels.
   * @default 3
   * @see #getTargetWidth()
   * @see #setTargetWidth()
   */
  public native function get targetWidth():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set targetWidth(value:Number):void;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Bullet-cfg-base" rel="Ext.sparkline.Bullet-cfg-base" class="docClass">base</a>.
   */
  public native function getBase():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Bullet-cfg-performanceColor" rel="Ext.sparkline.Bullet-cfg-performanceColor" class="docClass">performanceColor</a>.
   */
  public native function getPerformanceColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Bullet-cfg-rangeColors" rel="Ext.sparkline.Bullet-cfg-rangeColors" class="docClass">rangeColors</a>.
   */
  public native function getRangeColors():Array;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Bullet-cfg-targetColor" rel="Ext.sparkline.Bullet-cfg-targetColor" class="docClass">targetColor</a>.
   */
  public native function getTargetColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Bullet-cfg-targetWidth" rel="Ext.sparkline.Bullet-cfg-targetWidth" class="docClass">targetWidth</a>.
   */
  public native function getTargetWidth():Number;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Bullet-cfg-base" rel="Ext.sparkline.Bullet-cfg-base" class="docClass">base</a>.
   * @param base The new value.
   */
  public native function setBase(base:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Bullet-cfg-performanceColor" rel="Ext.sparkline.Bullet-cfg-performanceColor" class="docClass">performanceColor</a>.
   * @param performanceColor The new value.
   */
  public native function setPerformanceColor(performanceColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Bullet-cfg-rangeColors" rel="Ext.sparkline.Bullet-cfg-rangeColors" class="docClass">rangeColors</a>.
   * @param rangeColors The new value.
   */
  public native function setRangeColors(rangeColors:Array):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Bullet-cfg-targetColor" rel="Ext.sparkline.Bullet-cfg-targetColor" class="docClass">targetColor</a>.
   * @param targetColor The new value.
   */
  public native function setTargetColor(targetColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Bullet-cfg-targetWidth" rel="Ext.sparkline.Bullet-cfg-targetWidth" class="docClass">targetWidth</a>.
   * @param targetWidth The new value.
   */
  public native function setTargetWidth(targetWidth:Number):void;
}
}