package ext.sparkline {

[Uses("ext.sparkline.SparklineBarBase")]
[Uses("ext.sparkline.SparklineBase")]
[Uses("ext.Widget")]
[Uses("ext.mixin.Pluggable")]
[Uses("ext.Base")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.Evented")]
[Uses("ext.mixin.Observable")]
[Native("Ext.sparkline.Discrete", require)]
/**
 * Plots a series of thin vertical lines based upon the input <a href="#!/api/Ext.sparkline.Discrete-cfg-values" rel="Ext.sparkline.Discrete-cfg-values" class="docClass">values</a> array.
 *
 * <p>See <a href="#!/api/Ext.sparkline.Base" rel="Ext.sparkline.Base" class="docClass">the base class</a> for a simple example.</p>
 */
public class SparklineDiscrete extends ext.sparkline.SparklineBarBase {
  /**
   * @param config @inheritDoc
   */
  public function SparklineDiscrete(config:ext.sparkline.SparklineDiscrete = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * If true then the y values supplied to plot will be clipped to fall
   * between <a href="#!/api/Ext.sparkline.Discrete-cfg-chartRangeMin" rel="Ext.sparkline.Discrete-cfg-chartRangeMin" class="docClass">chartRangeMin</a> and <a href="#!/api/Ext.sparkline.Discrete-cfg-chartRangeMax" rel="Ext.sparkline.Discrete-cfg-chartRangeMax" class="docClass">chartRangeMax</a> - By default chartRangeMin/Max just ensure that the chart
   * spans at least that range of values, but does not constrain it.
   * @default false
   * @see #getChartRangeClip()
   * @see #setChartRangeClip()
   */
  public native function get chartRangeClip():Boolean;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set chartRangeClip(value:Boolean):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The maximum value to use for the range of Y values of the chart - Defaults to the maximum value supplied.
   * @see #getChartRangeMax()
   * @see #setChartRangeMax()
   */
  public native function get chartRangeMax():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set chartRangeMax(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The minimum value to use for the range of Y values of the chart - Defaults to the minimum value supplied.
   * @see #getChartRangeMin()
   * @see #setChartRangeMin()
   */
  public native function get chartRangeMin():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set chartRangeMin(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * Height of each line in pixels - Defaults to 30% of the graph height.
   * @default 'auto'
   * @see #getLineHeight()
   * @see #setLineHeight()
   */
  public native function get lineHeight():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set lineHeight(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * Colour to use in combination with <a href="#!/api/Ext.sparkline.Discrete-cfg-thresholdValue" rel="Ext.sparkline.Discrete-cfg-thresholdValue" class="docClass">thresholdValue</a>
   * @see #getThresholdColor()
   * @see #setThresholdColor()
   */
  public native function get thresholdColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set thresholdColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * Values less than this value will be drawn using <a href="#!/api/Ext.sparkline.Discrete-cfg-thresholdColor" rel="Ext.sparkline.Discrete-cfg-thresholdColor" class="docClass">thresholdColor</a> instead of lineColor
   * @default 0
   * @see #getThresholdValue()
   * @see #setThresholdValue()
   */
  public native function get thresholdValue():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set thresholdValue(value:Number):void;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-chartRangeClip" rel="Ext.sparkline.Discrete-cfg-chartRangeClip" class="docClass">chartRangeClip</a>.
   */
  public native function getChartRangeClip():Boolean;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-chartRangeMax" rel="Ext.sparkline.Discrete-cfg-chartRangeMax" class="docClass">chartRangeMax</a>.
   */
  public native function getChartRangeMax():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-chartRangeMin" rel="Ext.sparkline.Discrete-cfg-chartRangeMin" class="docClass">chartRangeMin</a>.
   */
  public native function getChartRangeMin():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-lineHeight" rel="Ext.sparkline.Discrete-cfg-lineHeight" class="docClass">lineHeight</a>.
   */
  public native function getLineHeight():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-thresholdColor" rel="Ext.sparkline.Discrete-cfg-thresholdColor" class="docClass">thresholdColor</a>.
   */
  public native function getThresholdColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-thresholdValue" rel="Ext.sparkline.Discrete-cfg-thresholdValue" class="docClass">thresholdValue</a>.
   */
  public native function getThresholdValue():Number;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-chartRangeClip" rel="Ext.sparkline.Discrete-cfg-chartRangeClip" class="docClass">chartRangeClip</a>.
   * @param chartRangeClip The new value.
   */
  public native function setChartRangeClip(chartRangeClip:Boolean):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-chartRangeMax" rel="Ext.sparkline.Discrete-cfg-chartRangeMax" class="docClass">chartRangeMax</a>.
   * @param chartRangeMax The new value.
   */
  public native function setChartRangeMax(chartRangeMax:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-chartRangeMin" rel="Ext.sparkline.Discrete-cfg-chartRangeMin" class="docClass">chartRangeMin</a>.
   * @param chartRangeMin The new value.
   */
  public native function setChartRangeMin(chartRangeMin:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-lineHeight" rel="Ext.sparkline.Discrete-cfg-lineHeight" class="docClass">lineHeight</a>.
   * @param lineHeight The new value.
   */
  public native function setLineHeight(lineHeight:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-thresholdColor" rel="Ext.sparkline.Discrete-cfg-thresholdColor" class="docClass">thresholdColor</a>.
   * @param thresholdColor The new value.
   */
  public native function setThresholdColor(thresholdColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Discrete-cfg-thresholdValue" rel="Ext.sparkline.Discrete-cfg-thresholdValue" class="docClass">thresholdValue</a>.
   * @param thresholdValue The new value.
   */
  public native function setThresholdValue(thresholdValue:Number):void;
}
}