package ext.sparkline {

[Uses("ext.sparkline.SparklineBase")]
[Uses("ext.Widget")]
[Uses("ext.mixin.Pluggable")]
[Uses("ext.Base")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.Evented")]
[Uses("ext.mixin.Observable")]
[Native("Ext.sparkline.Line", require)]
/**
 * Plots a line graph based upon the input <a href="#!/api/Ext.sparkline.Line-cfg-values" rel="Ext.sparkline.Line-cfg-values" class="docClass">values</a> array.
 *
 * <p>See <a href="#!/api/Ext.sparkline.Base" rel="Ext.sparkline.Base" class="docClass">the base class</a> for a simple example.</p>
 */
public class SparklineLine extends ext.sparkline.SparklineBase {
  /**
   * @param config @inheritDoc
   */
  public function SparklineLine(config:ext.sparkline.SparklineLine = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The maximum value to use for the range of Y values of the chart - Defaults to the minimum value supplied.
   * @see #getChartRangeMax()
   * @see #setChartRangeMax()
   */
  public native function get chartRangeMax():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set chartRangeMax(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The maximum value to use for the X value of the chart.
   * @see #getChartRangeMaxX()
   * @see #setChartRangeMaxX()
   */
  public native function get chartRangeMaxX():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set chartRangeMaxX(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The minimum value to use for the range of Y values of the chart - Defaults to the minimum value supplied.
   * @see #getChartRangeMin()
   * @see #setChartRangeMin()
   */
  public native function get chartRangeMin():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set chartRangeMin(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The minimum value to use for the X value of the chart.
   * @see #getChartRangeMinX()
   * @see #setChartRangeMinX()
   */
  public native function get chartRangeMinX():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set chartRangeMinX(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * Configure as <code>true</code> to draw the normal range overlaying the chart.
   * @default false
   * @see #getDrawNormalOnTop()
   * @see #setDrawNormalOnTop()
   */
  public native function get drawNormalOnTop():Boolean;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set drawNormalOnTop(value:Boolean):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The hex value for fill color.
   * @default #def
   * @see #getFillColor()
   * @see #setFillColor()
   */
  public native function get fillColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set fillColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The colour of value line shown when the graph is mouseovered.
   * @default #f22
   * @see #getHighlightLineColor()
   * @see #setHighlightLineColor()
   */
  public native function get highlightLineColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set highlightLineColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The colour of value marker spots when mouseovered.
   * @default #5f5
   * @see #getHighlightSpotColor()
   * @see #setHighlightSpotColor()
   */
  public native function get highlightSpotColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set highlightSpotColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The pixel width of the line plotted.
   * @default 1
   * @see #getLineWidth()
   * @see #setLineWidth()
   */
  public native function get lineWidth():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set lineWidth(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The colour of the maximum value marker. Set to false or an empty string to hide it.
   * @default #f80
   * @see #getMaxSpotColor()
   * @see #setMaxSpotColor()
   */
  public native function get maxSpotColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set maxSpotColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The colour of the mimimum value marker. Set to false or an empty string to hide it.
   * @default #f80
   * @see #getMinSpotColor()
   * @see #setMinSpotColor()
   */
  public native function get minSpotColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set minSpotColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * See <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeMin" rel="Ext.sparkline.Line-cfg-normalRangeMin" class="docClass">normalRangeMin</a> and <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeMax" rel="Ext.sparkline.Line-cfg-normalRangeMax" class="docClass">normalRangeMax</a> The color of the undererlayed "normal range bar".
   * @default #ccc
   * @see #getNormalRangeColor()
   * @see #setNormalRangeColor()
   */
  public native function get normalRangeColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set normalRangeColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * See <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeMin" rel="Ext.sparkline.Line-cfg-normalRangeMin" class="docClass">normalRangeMin</a> The maximum value to overlay a "normal range bar" over the graph using the <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeColor" rel="Ext.sparkline.Line-cfg-normalRangeColor" class="docClass">normalRangeColor</a>.
   * @see #getNormalRangeMax()
   * @see #setNormalRangeMax()
   */
  public native function get normalRangeMax():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set normalRangeMax(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * See <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeMax" rel="Ext.sparkline.Line-cfg-normalRangeMax" class="docClass">normalRangeMax</a> The minimum value to overlay a "normal range bar" over the graph using the <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeColor" rel="Ext.sparkline.Line-cfg-normalRangeColor" class="docClass">normalRangeColor</a>.
   * @see #getNormalRangeMin()
   * @see #setNormalRangeMin()
   */
  public native function get normalRangeMin():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set normalRangeMin(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The colour of the final value marker. Set to false or an empty string to hide it.
   * @default #f80
   * @see #getSpotColor()
   * @see #setSpotColor()
   */
  public native function get spotColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set spotColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The pixel radius of min, max and final value dots.
   * @default 1.5
   * @see #getSpotRadius()
   * @see #setSpotRadius()
   */
  public native function get spotRadius():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set spotRadius(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * An object which uses range specifiers as keys to indicate spot color values
   * for range of values. A range specifier is of the form <code>[number]:[number]</code> indicating start and end range.
   * Omitting aither means an open ended range. For example to render green spots on all values less than 50
   * and red on values higher than 50 use:
   *
   * <p>   {
   *        // Open ended range, with max value 49
   *        ":49": "green",</p>
   *
   * <pre><code>   // Open ended range, with min value 50
   *    "50:": "red"
   * </code></pre>
   *
   * <p>   }</p>
   * @see #getValueSpots()
   * @see #setValueSpots()
   */
  public native function get valueSpots():Object;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set valueSpots(value:Object):void;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-chartRangeMax" rel="Ext.sparkline.Line-cfg-chartRangeMax" class="docClass">chartRangeMax</a>.
   */
  public native function getChartRangeMax():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-chartRangeMaxX" rel="Ext.sparkline.Line-cfg-chartRangeMaxX" class="docClass">chartRangeMaxX</a>.
   */
  public native function getChartRangeMaxX():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-chartRangeMin" rel="Ext.sparkline.Line-cfg-chartRangeMin" class="docClass">chartRangeMin</a>.
   */
  public native function getChartRangeMin():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-chartRangeMinX" rel="Ext.sparkline.Line-cfg-chartRangeMinX" class="docClass">chartRangeMinX</a>.
   */
  public native function getChartRangeMinX():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-drawNormalOnTop" rel="Ext.sparkline.Line-cfg-drawNormalOnTop" class="docClass">drawNormalOnTop</a>.
   */
  public native function getDrawNormalOnTop():Boolean;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-fillColor" rel="Ext.sparkline.Line-cfg-fillColor" class="docClass">fillColor</a>.
   */
  public native function getFillColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-highlightLineColor" rel="Ext.sparkline.Line-cfg-highlightLineColor" class="docClass">highlightLineColor</a>.
   */
  public native function getHighlightLineColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-highlightSpotColor" rel="Ext.sparkline.Line-cfg-highlightSpotColor" class="docClass">highlightSpotColor</a>.
   */
  public native function getHighlightSpotColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-lineWidth" rel="Ext.sparkline.Line-cfg-lineWidth" class="docClass">lineWidth</a>.
   */
  public native function getLineWidth():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-maxSpotColor" rel="Ext.sparkline.Line-cfg-maxSpotColor" class="docClass">maxSpotColor</a>.
   */
  public native function getMaxSpotColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-minSpotColor" rel="Ext.sparkline.Line-cfg-minSpotColor" class="docClass">minSpotColor</a>.
   */
  public native function getMinSpotColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeColor" rel="Ext.sparkline.Line-cfg-normalRangeColor" class="docClass">normalRangeColor</a>.
   */
  public native function getNormalRangeColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeMax" rel="Ext.sparkline.Line-cfg-normalRangeMax" class="docClass">normalRangeMax</a>.
   */
  public native function getNormalRangeMax():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeMin" rel="Ext.sparkline.Line-cfg-normalRangeMin" class="docClass">normalRangeMin</a>.
   */
  public native function getNormalRangeMin():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-spotColor" rel="Ext.sparkline.Line-cfg-spotColor" class="docClass">spotColor</a>.
   */
  public native function getSpotColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-spotRadius" rel="Ext.sparkline.Line-cfg-spotRadius" class="docClass">spotRadius</a>.
   */
  public native function getSpotRadius():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Line-cfg-valueSpots" rel="Ext.sparkline.Line-cfg-valueSpots" class="docClass">valueSpots</a>.
   */
  public native function getValueSpots():Object;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-chartRangeMax" rel="Ext.sparkline.Line-cfg-chartRangeMax" class="docClass">chartRangeMax</a>.
   * @param chartRangeMax The new value.
   */
  public native function setChartRangeMax(chartRangeMax:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-chartRangeMaxX" rel="Ext.sparkline.Line-cfg-chartRangeMaxX" class="docClass">chartRangeMaxX</a>.
   * @param chartRangeMaxX The new value.
   */
  public native function setChartRangeMaxX(chartRangeMaxX:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-chartRangeMin" rel="Ext.sparkline.Line-cfg-chartRangeMin" class="docClass">chartRangeMin</a>.
   * @param chartRangeMin The new value.
   */
  public native function setChartRangeMin(chartRangeMin:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-chartRangeMinX" rel="Ext.sparkline.Line-cfg-chartRangeMinX" class="docClass">chartRangeMinX</a>.
   * @param chartRangeMinX The new value.
   */
  public native function setChartRangeMinX(chartRangeMinX:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-drawNormalOnTop" rel="Ext.sparkline.Line-cfg-drawNormalOnTop" class="docClass">drawNormalOnTop</a>.
   * @param drawNormalOnTop The new value.
   */
  public native function setDrawNormalOnTop(drawNormalOnTop:Boolean):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-fillColor" rel="Ext.sparkline.Line-cfg-fillColor" class="docClass">fillColor</a>.
   * @param fillColor The new value.
   */
  public native function setFillColor(fillColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-highlightLineColor" rel="Ext.sparkline.Line-cfg-highlightLineColor" class="docClass">highlightLineColor</a>.
   * @param highlightLineColor The new value.
   */
  public native function setHighlightLineColor(highlightLineColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-highlightSpotColor" rel="Ext.sparkline.Line-cfg-highlightSpotColor" class="docClass">highlightSpotColor</a>.
   * @param highlightSpotColor The new value.
   */
  public native function setHighlightSpotColor(highlightSpotColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-lineWidth" rel="Ext.sparkline.Line-cfg-lineWidth" class="docClass">lineWidth</a>.
   * @param lineWidth The new value.
   */
  public native function setLineWidth(lineWidth:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-maxSpotColor" rel="Ext.sparkline.Line-cfg-maxSpotColor" class="docClass">maxSpotColor</a>.
   * @param maxSpotColor The new value.
   */
  public native function setMaxSpotColor(maxSpotColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-minSpotColor" rel="Ext.sparkline.Line-cfg-minSpotColor" class="docClass">minSpotColor</a>.
   * @param minSpotColor The new value.
   */
  public native function setMinSpotColor(minSpotColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeColor" rel="Ext.sparkline.Line-cfg-normalRangeColor" class="docClass">normalRangeColor</a>.
   * @param normalRangeColor The new value.
   */
  public native function setNormalRangeColor(normalRangeColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeMax" rel="Ext.sparkline.Line-cfg-normalRangeMax" class="docClass">normalRangeMax</a>.
   * @param normalRangeMax The new value.
   */
  public native function setNormalRangeMax(normalRangeMax:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-normalRangeMin" rel="Ext.sparkline.Line-cfg-normalRangeMin" class="docClass">normalRangeMin</a>.
   * @param normalRangeMin The new value.
   */
  public native function setNormalRangeMin(normalRangeMin:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-spotColor" rel="Ext.sparkline.Line-cfg-spotColor" class="docClass">spotColor</a>.
   * @param spotColor The new value.
   */
  public native function setSpotColor(spotColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-spotRadius" rel="Ext.sparkline.Line-cfg-spotRadius" class="docClass">spotRadius</a>.
   * @param spotRadius The new value.
   */
  public native function setSpotRadius(spotRadius:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Line-cfg-valueSpots" rel="Ext.sparkline.Line-cfg-valueSpots" class="docClass">valueSpots</a>.
   * @param valueSpots The new value.
   */
  public native function setValueSpots(valueSpots:Object):void;
}
}