package ext.state {

[Uses("ext.state.SStateManager")]
[Uses("ext.Base")]
[Native("Ext.state.Manager", require)]
/**
 * This is the global state manager. By default all components that are "state aware" check this class
 * for state information if you don't pass them a custom state provider. In order for this class
 * to be useful, it must be initialized with a provider when your application initializes. Example usage:
 *
 * <pre><code> // in your initialization function
 *  init: function() {
 *      <a href="#!/api/Ext.state.Manager-method-setProvider" rel="Ext.state.Manager-method-setProvider" class="docClass">Ext.state.Manager.setProvider</a>(new <a href="#!/api/Ext.state.CookieProvider" rel="Ext.state.CookieProvider" class="docClass">Ext.state.CookieProvider</a>());
 *  }
 * </code></pre>
 *
 * <p>This class passes on calls from components to the underlying <a href="#!/api/Ext.state.Provider" rel="Ext.state.Provider" class="docClass">Ext.state.Provider</a> so that
 * there is a common interface that can be used without needing to refer to a specific provider instance
 * in every component.</p>
 */
public const StateManager:ext.state.SStateManager;
}