package ext.toolbar {
import ext.Component;

[Uses("ext.Component")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.Base")]
[Uses("ext.util.ElementContainer")]
[Uses("ext.util.Floating")]
[Uses("ext.util.Positionable")]
[Uses("ext.state.Stateful")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.Keyboard")]
[Uses("ext.mixin.Accessible")]
[Uses("ext.mixin.Observable")]
[Uses("ext.util.Renderable")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.util.Focusable")]
[Uses("ext.util.Animate")]
[Native("Ext.toolbar.Fill", require)]
/**
 * A non-rendering placeholder item which instructs the Toolbar's Layout to begin using
 * the right-justified button container.
 *
 * <pre class='inline-example '><code><a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.panel.Panel" rel="Ext.panel.Panel" class="docClass">Ext.panel.Panel</a>', {
 *      title: 'Toolbar Fill Example',
 *      width: 300,
 *      height: 200,
 *      tbar : [
 *          'Item 1',
 *          { xtype: 'tbfill' },
 *          'Item 2'
 *      ],
 *      renderTo: <a href="#!/api/Ext-method-getBody" rel="Ext-method-getBody" class="docClass">Ext.getBody</a>()
 *  });
 * </code></pre>
 */
public class Fill extends ext.Component {
  /**
   * @param config @inheritDoc
   */
  public function Fill(config:ext.toolbar.Fill = null) {
    super();
  }

  /**
   * <code>true</code> in this class to identify an object as an instantiated Fill, or subclass thereof.
   * @default true
   */
  public native function get isFill():Boolean;

  /**
   * @private
   */
  public native function set isFill(value:Boolean):void;
}
}