package ext.tree {
import ext.grid.column.Column;

[Uses("ext.grid.column.Column")]
[Uses("ext.grid.header.HeaderContainer")]
[Uses("ext.container.Container")]
[Uses("ext.Component")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.Base")]
[Uses("ext.util.ElementContainer")]
[Uses("ext.util.Floating")]
[Uses("ext.util.Positionable")]
[Uses("ext.state.Stateful")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.Keyboard")]
[Uses("ext.mixin.Accessible")]
[Uses("ext.mixin.Observable")]
[Uses("ext.util.Renderable")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.util.Focusable")]
[Uses("ext.util.Animate")]
[Uses("ext.mixin.Queryable")]
[Uses("ext.mixin.Container")]
[Uses("ext.util.FocusableContainer")]
[Native("Ext.tree.Column", require)]
/**
 * Provides indentation and folder structure markup for a Tree taking into account
 * depth and position within the tree hierarchy.
 */
public class TreeColumn extends ext.grid.column.Column {
  /**
   * @param config @inheritDoc
   */
  public function TreeColumn(config:ext.tree.TreeColumn = null) {
    super();
  }

  [ExtConfig]
  /**
   * A renderer is an 'interceptor' method which can be used to transform data (value,
   * appearance, etc.) before it is rendered. Note that a <em>tree column</em> renderer yields
   * the <em>text</em> of the node. The lines and icons are produced by configurations. See
   * below for more information.
   *
   * <p><strong>NOTE:</strong> In previous releases, a string was treated as a method on
   * <code><a href="#!/api/Ext.util.Format" rel="Ext.util.Format" class="docClass">Ext.util.Format</a></code> but that is now handled by the <a href="#!/api/Ext.tree.Column-cfg-formatter" rel="Ext.tree.Column-cfg-formatter" class="docClass">formatter</a> config.</p>
   */
  override public native function get renderer():*;

  [ExtConfig]
  /**
   * @private
   */
  override public native function set renderer(value:*):void;
}
}