package ext.util {

[Uses("ext.util.SHistory")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Native("Ext.util.History", require)]
/**
 * History management component that allows you to register arbitrary tokens that signify application
 * history state on navigation actions.  You can then handle the history <a href="#!/api/Ext.util.History-event-change" rel="Ext.util.History-event-change" class="docClass">change</a> event in order
 * to reset your application UI to the appropriate state when the user navigates forward or backward through
 * the browser history stack.
 *
 * <h2>Initializing</h2>
 *
 * <p>The <a href="#!/api/Ext.util.History-method-init" rel="Ext.util.History-method-init" class="docClass">init</a> method of the History object must be called before using History. This sets up the internal
 * state and must be the first thing called before using History.</p>
 */
public const History:ext.util.SHistory;
}