package ext.util {
import ext.Base;

[Uses("ext.Base")]
[Native]
/**
 * Base64 is a group of similar binary-to-text encoding schemes that represent binary data in an ASCII string format by
 * translating it into a radix-64 representation.
 *
 * <p>This class is an implementation of base64 encoding and decoding functions and is UTF-8 safe.</p>
 * <p>Type of singleton Base64.</p>
 * @see ext.util.#Base64 ext.util.Base64
 */
public class SBase64 extends ext.Base {
  /**
   * Decodes given base64 formatted string
   */
  public native function decode(input:Object):String;

  /**
   * Encodes given string in to base64 formatted string
   */
  public native function encode(input:Object):String;
}
}