package ext.util {
import ext.Base;
import ext.mixin.Observable;

[Uses("ext.Base")]
[Native("Ext.util.Schedulable", require)]
[ExcludeClass]
/**
 * This is a base class for objects that can be managed by <code><a href="#!/api/Ext.util.Scheduler" rel="Ext.util.Scheduler" class="docClass">Ext.util.Scheduler</a></code>.
 */
public class Schedulable extends ext.Base {
  /**
   * This method returns the <code>Scheduler</code> for this item.
   */
  public native function getScheduler():ext.mixin.Observable;

  /**
   * Schedules this item with the associated <code><a href="#!/api/Ext.util.Scheduler" rel="Ext.util.Scheduler" class="docClass">Ext.util.Scheduler</a></code>.
   */
  public native function schedule():void;

  /**
   * This method should be overridden by items that have dependencies to insert. The
   * standard form would be:
   *
   * <pre><code> sort: function () {
   *      this.getScheduler().sortItems(this.dependencies);
   *  }
   * </code></pre>
   *
   * <p>This example assumes the item has a "dependencies" array to pass to the scheduler.</p>
   */
  public native function sort():void;

  /**
   * Unschedules this item with the associated <code><a href="#!/api/Ext.util.Scheduler" rel="Ext.util.Scheduler" class="docClass">Ext.util.Scheduler</a></code>.
   */
  public native function unschedule():void;
}
}