package ext.util {

[Uses("ext.util.TaskRunner")]
[Uses("ext.Base")]
[Native("Ext.util.TaskManager", require)]
/**
 * A static <a href="#!/api/Ext.util.TaskRunner" rel="Ext.util.TaskRunner" class="docClass">Ext.util.TaskRunner</a> instance that can be used to start and stop
 * arbitrary tasks. See <a href="#!/api/Ext.util.TaskRunner" rel="Ext.util.TaskRunner" class="docClass">Ext.util.TaskRunner</a> for supported methods and task
 * config properties.
 *
 * <pre class='inline-example '><code>var task, clock;
 *
 * clock = <a href="#!/api/Ext-method-getBody" rel="Ext-method-getBody" class="docClass">Ext.getBody</a>().appendChild({
 *     id: 'clock'
 * });
 *
 * // Start a simple clock task that updates a div once per second
 * task = {
 *     run: function() {
 *         clock.setHtml(<a href="#!/api/Ext.Date-method-format" rel="Ext.Date-method-format" class="docClass">Ext.Date.format</a>(new Date(), 'g:i:s A'));
 *     },
 *     interval: 1000
 * };
 *
 * <a href="#!/api/Ext.util.TaskManager-method-start" rel="Ext.util.TaskManager-method-start" class="docClass">Ext.TaskManager.start</a>(task);
 * </code></pre>
 *
 * <p>See the <a href="#!/api/Ext.util.TaskManager-method-start" rel="Ext.util.TaskManager-method-start" class="docClass">start</a> method for details about how to configure a task object.</p>
 */
public const TaskManager:ext.util.TaskRunner;
}