package ext.util {

[Native("Ext.util.TaskRunner.Task", require)]
/**
 * Instances of this class are created by <a href="#!/api/Ext.util.TaskRunner-method-newTask" rel="Ext.util.TaskRunner-method-newTask" class="docClass">Ext.util.TaskRunner.newTask</a> method.
 *
 * <p>For details on config properties, see <a href="#!/api/Ext.util.TaskRunner-method-start" rel="Ext.util.TaskRunner-method-start" class="docClass">Ext.util.TaskRunner.start</a>.</p>
 */
public class TaskRunnerTask {
  /**
   * Destroys this instance, stopping this task's execution.
   */
  public native function destroy():void;

  /**
   * Restarts this task, clearing it duration, expiration and run count.
   * @param interval Optionally reset this task's interval.
   */
  public native function restart(interval:Number = NaN):void;

  /**
   * Starts this task if it is not already started.
   * @param interval Optionally reset this task's interval.
   */
  public native function start(interval:Number = NaN):void;

  /**
   * Stops this task.
   */
  public native function stop():void;
}
}