package ext.view {
import ext.data.Model;
import ext.dom.Element;
import ext.grid.CellContext;
import js.HTMLElement;

[Uses("ext.view.AbstractView")]
[Uses("ext.Component")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.Base")]
[Uses("ext.util.ElementContainer")]
[Uses("ext.util.Floating")]
[Uses("ext.util.Positionable")]
[Uses("ext.state.Stateful")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.Keyboard")]
[Uses("ext.mixin.Accessible")]
[Uses("ext.mixin.Observable")]
[Uses("ext.util.Renderable")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.util.Focusable")]
[Uses("ext.util.Animate")]
[Uses("ext.util.StoreHolder")]
[Native("Ext.view.View", require)]
/**
 * Fires before the click event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.view.events.DataView_eEvent.BEFORE_CONTAINER_CLICK
 */
[Event(name = 'onBeforeContainerClick', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires before the contextmenu event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.view.events.DataView_eEvent.BEFORE_CONTAINER_CONTEXT_MENU
 */
[Event(name = 'onBeforeContainerContextMenu', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires before the dblclick event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.view.events.DataView_eEvent.BEFORE_CONTAINER_DBLCLICK
 */
[Event(name = 'onBeforeContainerDblclick', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires before the keydown event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.view.events.DataView_eEvent.BEFORE_CONTAINER_KEY_DOWN
 */
[Event(name = 'onBeforeContainerKeyDown', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires before the keypress event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.view.events.DataView_eEvent.BEFORE_CONTAINER_KEYPRESS
 */
[Event(name = 'onBeforeContainerKeypress', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires before the keyup event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.view.events.DataView_eEvent.BEFORE_CONTAINER_KEY_UP
 */
[Event(name = 'onBeforeContainerKeyUp', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires before the mousedown event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.view.events.DataView_eEvent.BEFORE_CONTAINER_MOUSE_DOWN
 */
[Event(name = 'onBeforeContainerMouseDown', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires before the mouseout event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.view.events.DataView_eEvent.BEFORE_CONTAINER_MOUSE_OUT
 */
[Event(name = 'onBeforeContainerMouseOut', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires before the mouseover event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.view.events.DataView_eEvent.BEFORE_CONTAINER_MOUSE_OVER
 */
[Event(name = 'onBeforeContainerMouseOver', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires before the mouseup event on the container is processed. Returns false to cancel the default action.
 * @eventType ext.view.events.DataView_eEvent.BEFORE_CONTAINER_MOUSE_UP
 */
[Event(name = 'onBeforeContainerMouseUp', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fired before a record is deselected. If any listener returns false, the
 * deselection is cancelled.
 * @eventType ext.view.events.DataView_record_indexEvent.BEFORE_DESELECT
 */
[Event(name = 'onBeforeDeselect', type = 'ext.view.events.DataView_record_indexEvent')]
/**
 * Fires before the click event on an item is processed. Return false to cancel the
 * default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_CLICK
 */
[Event(name = 'onBeforeItemClick', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires before the contextmenu event on an item is processed. Return false to
 * cancel the default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_CONTEXT_MENU
 */
[Event(name = 'onBeforeItemContextMenu', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires before the dblclick event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_DBLCLICK
 */
[Event(name = 'onBeforeItemDblclick', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires before the keydown event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_KEY_DOWN
 */
[Event(name = 'onBeforeItemKeyDown', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires before the keypress event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_KEYPRESS
 */
[Event(name = 'onBeforeItemKeypress', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires before the keyup event on an item is processed. Return false to cancel the
 * default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_KEY_UP
 */
[Event(name = 'onBeforeItemKeyUp', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires before the longpress event on an item is processed. Return false to
 * cancel the default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_LONG_PRESS
 */
[Event(name = 'onBeforeItemLongPress', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires before the mousedown event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_MOUSE_DOWN
 */
[Event(name = 'onBeforeItemMouseDown', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires before the mouseenter event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_MOUSE_ENTER
 */
[Event(name = 'onBeforeItemMouseEnter', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires before the mouseleave event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_MOUSE_LEAVE
 */
[Event(name = 'onBeforeItemMouseLeave', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires before the mouseup event on an item is processed. Return false to cancel
 * the default action.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.BEFORE_ITEM_MOUSE_UP
 */
[Event(name = 'onBeforeItemMouseUp', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fired before a record is selected. If any listener returns false, the
 * selection is cancelled.
 * @eventType ext.view.events.DataView_record_indexEvent.BEFORE_SELECT
 */
[Event(name = 'onBeforeSelect', type = 'ext.view.events.DataView_record_indexEvent')]
/**
 * Fires when the container is clicked.
 * @eventType ext.view.events.DataView_eEvent.CONTAINER_CLICK
 */
[Event(name = 'onContainerClick', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires when the container is right clicked.
 * @eventType ext.view.events.DataView_eEvent.CONTAINER_CONTEXT_MENU
 */
[Event(name = 'onContainerContextMenu', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires when the container is double clicked.
 * @eventType ext.view.events.DataView_eEvent.CONTAINER_DBLCLICK
 */
[Event(name = 'onContainerDblclick', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires when a key is pressed down while the container is focused, and no item is currently selected.
 * @eventType ext.view.events.DataView_eEvent.CONTAINER_KEY_DOWN
 */
[Event(name = 'onContainerKeyDown', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires when a key is pressed while the container is focused, and no item is currently selected.
 * @eventType ext.view.events.DataView_eEvent.CONTAINER_KEYPRESS
 */
[Event(name = 'onContainerKeypress', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires when a key is released while the container is focused, and no item is currently selected.
 * @eventType ext.view.events.DataView_eEvent.CONTAINER_KEY_UP
 */
[Event(name = 'onContainerKeyUp', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires when there is a mousedown on the container
 * @eventType ext.view.events.DataView_eEvent.CONTAINER_MOUSE_DOWN
 */
[Event(name = 'onContainerMouseDown', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires when you move the mouse out of the container.
 * @eventType ext.view.events.DataView_eEvent.CONTAINER_MOUSE_OUT
 */
[Event(name = 'onContainerMouseOut', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires when you move the mouse over the container.
 * @eventType ext.view.events.DataView_eEvent.CONTAINER_MOUSE_OVER
 */
[Event(name = 'onContainerMouseOver', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fires when there is a mouseup on the container
 * @eventType ext.view.events.DataView_eEvent.CONTAINER_MOUSE_UP
 */
[Event(name = 'onContainerMouseUp', type = 'ext.view.events.DataView_eEvent')]
/**
 * Fired after a record is deselected
 * @eventType ext.view.events.DataView_recordEvent.DESELECT
 */
[Event(name = 'onDeselect', type = 'ext.view.events.DataView_recordEvent')]
/**
 * Fired when a row is focused
 * @eventType ext.view.events.DataView_oldFocused_newFocusedEvent.FOCUS_CHANGE
 */
[Event(name = 'onFocusChange', type = 'ext.view.events.DataView_oldFocused_newFocusedEvent')]
/**
 * Fires when a node is highlighted using keyboard navigation, or mouseover.
 * @eventType ext.view.events.DataView_nodeEvent.HIGHLIGHT_ITEM
 */
[Event(name = 'onHighlightItem', type = 'ext.view.events.DataView_nodeEvent')]
/**
 * Fires when an item is clicked.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_CLICK
 */
[Event(name = 'onItemClick', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires when an item is right clicked.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_CONTEXT_MENU
 */
[Event(name = 'onItemContextMenu', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires when an item is double clicked.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_DBLCLICK
 */
[Event(name = 'onItemDblclick', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires when a key is pressed down while an item is currently selected.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_KEY_DOWN
 */
[Event(name = 'onItemKeyDown', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires when a key is pressed while an item is currently selected.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_KEYPRESS
 */
[Event(name = 'onItemKeypress', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires when a key is released while an item is currently selected.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_KEY_UP
 */
[Event(name = 'onItemKeyUp', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires on a longpress event on an item.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_LONG_PRESS
 */
[Event(name = 'onItemLongPress', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires when there is a mouse down on an item
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_MOUSE_DOWN
 */
[Event(name = 'onItemMouseDown', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires when the mouse enters an item.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_MOUSE_ENTER
 */
[Event(name = 'onItemMouseEnter', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires when the mouse leaves an item.
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_MOUSE_LEAVE
 */
[Event(name = 'onItemMouseLeave', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fires when there is a mouse up on an item
 * @eventType ext.view.events.DataView_record_item_index_eEvent.ITEM_MOUSE_UP
 */
[Event(name = 'onItemMouseUp', type = 'ext.view.events.DataView_record_item_index_eEvent')]
/**
 * Fired after a record is selected
 * @eventType ext.view.events.DataView_record_indexEvent.SELECT
 */
[Event(name = 'onSelect', type = 'ext.view.events.DataView_record_indexEvent')]
/**
 * Fired after a selection change has occurred
 * @eventType ext.view.events.DataView_selectedEvent.SELECTION_CHANGE
 */
[Event(name = 'onSelectionChange', type = 'ext.view.events.DataView_selectedEvent')]
/**
 * Fires when a node is unhighlighted using keyboard navigation, or mouseout.
 * @eventType ext.view.events.DataView_nodeEvent.UNHIGHLIGHT_ITEM
 */
[Event(name = 'onUnhighlightItem', type = 'ext.view.events.DataView_nodeEvent')]
/**
 * A mechanism for displaying data using custom layout templates and formatting.
 *
 * <p>The View uses an <a href="#!/api/Ext.XTemplate" rel="Ext.XTemplate" class="docClass">Ext.XTemplate</a> as its internal templating mechanism, and is bound to an
 * <a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a> so that as the data in the store changes the view is automatically updated
 * to reflect the changes. The view also provides built-in behavior for many common events that can
 * occur for its contained items including click, doubleclick, mouseover, mouseout, etc. as well as a
 * built-in selection model. <strong>In order to use these features, an <a href="#!/api/Ext.view.View-cfg-itemSelector" rel="Ext.view.View-cfg-itemSelector" class="docClass">itemSelector</a> config must
 * be provided for the View to determine what nodes it will be working with.</strong></p>
 *
 * <p>The example below binds a View to a <a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a> and renders it into an <a href="#!/api/Ext.panel.Panel" rel="Ext.panel.Panel" class="docClass">Ext.panel.Panel</a>.</p>
 *
 * <pre class='inline-example '><code><a href="#!/api/Ext-method-define" rel="Ext-method-define" class="docClass">Ext.define</a>('Image', {
 *     extend: '<a href="#!/api/Ext.data.Model" rel="Ext.data.Model" class="docClass">Ext.data.Model</a>',
 *     fields: [
 *         { name:'src', type:'string' },
 *         { name:'caption', type:'string' }
 *     ]
 * });
 *
 * <a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a>', {
 *     id:'imagesStore',
 *     model: 'Image',
 *     data: [
 *         { src:'http://www.sencha.com/img/20110215-feat-drawing.png', caption:'Drawing &amp; Charts' },
 *         { src:'http://www.sencha.com/img/20110215-feat-data.png', caption:'Advanced Data' },
 *         { src:'http://www.sencha.com/img/20110215-feat-html5.png', caption:'Overhauled Theme' },
 *         { src:'http://www.sencha.com/img/20110215-feat-perf.png', caption:'Performance Tuned' }
 *     ]
 * });
 *
 * var imageTpl = new <a href="#!/api/Ext.XTemplate" rel="Ext.XTemplate" class="docClass">Ext.XTemplate</a>(
 *     '&lt;tpl for="."&gt;',
 *         '&lt;div style="margin-bottom: 10px;" class="thumb-wrap"&gt;',
 *           '&lt;img src="{src}" /&gt;',
 *           '&lt;br/&gt;&lt;span&gt;{caption}&lt;/span&gt;',
 *         '&lt;/div&gt;',
 *     '&lt;/tpl&gt;'
 * );
 *
 * <a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.view.View" rel="Ext.view.View" class="docClass">Ext.view.View</a>', {
 *     store: <a href="#!/api/Ext.data.StoreManager-method-lookup" rel="Ext.data.StoreManager-method-lookup" class="docClass">Ext.data.StoreManager.lookup</a>('imagesStore'),
 *     tpl: imageTpl,
 *     itemSelector: 'div.thumb-wrap',
 *     emptyText: 'No images available',
 *     renderTo: <a href="#!/api/Ext-method-getBody" rel="Ext-method-getBody" class="docClass">Ext.getBody</a>()
 * });
 * </code></pre>
 *
 * <p><strong>From override focusNode:</strong> Focuses a particular row and brings it into view. Will fire the rowfocus event.</p>
 */
public class DataView extends ext.view.AbstractView {
  /**
   * @param config @inheritDoc
   */
  public function DataView(config:ext.view.DataView = null) {
    super();
  }

  /**
   * Only valid when a view is in actionableMode. The currently actioned row
   *
   * <p><strong>Defined in override focusNode.</strong></p>
   */
  public native function get actionRow():ext.dom.Element;

  /**
   * @private
   */
  public native function set actionRow(value:ext.dom.Element):void;

  /**
   * Sizes the passed header to fit the max content width.
   * <em>Note that group columns shrinkwrap around the size of leaf columns. Auto sizing a group column
   * autosizes descendant leaf columns.</em>
   *
   * <p><strong>Defined in override focusNode.</strong></p>
   * @param header The header (or index of header) to auto size.
   */
  public native function autoSizeColumn(header:*):void;

  /**
   * Un-highlights the currently highlighted item, if any.
   */
  public native function clearHighlight():void;

  [Deprecated(replacement = "autoSizeColumn")]
  /**
   * Expands a particular header to fit the max content width.
   *
   * <p><strong>Defined in override focusNode.</strong></p>
   */
  public native function expandToFit(header:Object):void;

  /**
   * Focuses a particular cell and brings it into view. Will fire the rowfocus event.
   *
   * <p><strong>Defined in override focusNode.</strong></p>
   * @param pos The cell to select
   * @param delay Delay the focus this number of milliseconds (true for 10 milliseconds).
   */
  public native function focusCell(pos:ext.grid.CellContext, delay:* = undefined):void;

  /**
   * Focuses a node in the view.
   * @param rec The record associated to the node that is to be focused.
   */
  public native function focusNode(rec:ext.data.Model):void;

  /**
   * Highlights a given item in the View. This is called by the mouseover handler if <a href="#!/api/Ext.view.View-cfg-overItemCls" rel="Ext.view.View-cfg-overItemCls" class="docClass">overItemCls</a>
   * and <a href="#!/api/Ext.view.View-cfg-trackOver" rel="Ext.view.View-cfg-trackOver" class="docClass">trackOver</a> are configured, but can also be called manually by other code, for instance to
   * handle stepping through the list via keyboard navigation.
   * @param item The item to highlight
   */
  public native function highlightItem(item:js.HTMLElement):void;

  /**
   * Navigates from the passed record by the passed increment which may be +ve or -ve
   *
   * <p>Skips hidden records.</p>
   *
   * <p>If no record is visible in the specified direction, returns the starting record index unchanged.</p>
   *
   * <p><strong>Defined in override focusNode.</strong></p>
   * @param startRec The Record to start from.
   * @param distance The distance to move from the record. May be +ve or -ve.
   */
  public native function walkRecs(startRec:ext.data.Model, distance:Number):void;
}
}