package ext.view.events {
import ext.data.Model;
import ext.event.Event;
import ext.view.TableView;
import js.HTMLElement;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class TableView_td_cellIndex_record_tr_rowIndex_eEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fired before the cell click is processed. Return false to cancel the default action.
   * @see ext.view.TableView
   * @eventType onBeforeCellClick
   */
  public static const BEFORE_CELL_CLICK:String = "onBeforeCellClick";

  /**
   * "Fired before the cell right click is processed. Return false to cancel the default action.
   * @see ext.view.TableView
   * @eventType onBeforeCellContextMenu
   */
  public static const BEFORE_CELL_CONTEXT_MENU:String = "onBeforeCellContextMenu";

  /**
   * "Fired before the cell double click is processed. Return false to cancel the default action.
   * @see ext.view.TableView
   * @eventType onBeforeCellDblclick
   */
  public static const BEFORE_CELL_DBLCLICK:String = "onBeforeCellDblclick";

  /**
   * "Fired before the cell key down is processed. Return false to cancel the default action.
   * @see ext.view.TableView
   * @eventType onBeforeCellKeyDown
   */
  public static const BEFORE_CELL_KEY_DOWN:String = "onBeforeCellKeyDown";

  /**
   * "Fired before the cell mouse down is processed. Return false to cancel the default action.
   * @see ext.view.TableView
   * @eventType onBeforeCellMouseDown
   */
  public static const BEFORE_CELL_MOUSE_DOWN:String = "onBeforeCellMouseDown";

  /**
   * "Fired before the cell mouse up is processed. Return false to cancel the default action.
   * @see ext.view.TableView
   * @eventType onBeforeCellMouseUp
   */
  public static const BEFORE_CELL_MOUSE_UP:String = "onBeforeCellMouseUp";

  /**
   * "Fired when table cell is clicked.
   * @see ext.view.TableView
   * @eventType onCellClick
   */
  public static const CELL_CLICK:String = "onCellClick";

  /**
   * "Fired when table cell is right clicked.
   * @see ext.view.TableView
   * @eventType onCellContextMenu
   */
  public static const CELL_CONTEXT_MENU:String = "onCellContextMenu";

  /**
   * "Fired when table cell is double clicked.
   * @see ext.view.TableView
   * @eventType onCellDblclick
   */
  public static const CELL_DBLCLICK:String = "onCellDblclick";

  /**
   * "Fired when the keydown event is captured on the cell.
   * @see ext.view.TableView
   * @eventType onCellKeyDown
   */
  public static const CELL_KEY_DOWN:String = "onCellKeyDown";

  /**
   * "Fired when the mousedown event is captured on the cell.
   * @see ext.view.TableView
   * @eventType onCellMouseDown
   */
  public static const CELL_MOUSE_DOWN:String = "onCellMouseDown";

  /**
   * "Fired when the mouseup event is captured on the cell.
   * @see ext.view.TableView
   * @eventType onCellMouseUp
   */
  public static const CELL_MOUSE_UP:String = "onCellMouseUp";

  public function TableView_td_cellIndex_record_tr_rowIndex_eEvent(type:String, arguments:Array) {
    super(null, null);
  }

  public native function get source():ext.view.TableView;

  /**
   * The TD element for the cell.
   */
  public native function get td():js.HTMLElement;

  public native function get cellIndex():Number;

  public native function get record():ext.data.Model;

  /**
   * The TR element for the cell.
   */
  public native function get tr():js.HTMLElement;

  public native function get rowIndex():Number;

  /**
   * <ul>
   *   <li><code>position</code> : ext.grid.CellContext
   * A CellContext object which defines the target cell.
   *   </li>
   * </ul>
   */
  public native function get e():ext.event.Event;
}
}