package ext.window.events {
import ext.window.Window;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class WindowEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires after the window has been visually activated via <a href="#!/api/Ext.window.Window-method-setActive" rel="Ext.window.Window-method-setActive" class="docClass">setActive</a>.
   * @see ext.window.Window
   * @eventType onActivate
   */
  public static const ACTIVATE:String = "onActivate";

  /**
   * "Fires after the window has been visually deactivated via <a href="#!/api/Ext.window.Window-method-setActive" rel="Ext.window.Window-method-setActive" class="docClass">setActive</a>.
   * @see ext.window.Window
   * @eventType onDeactivate
   */
  public static const DEACTIVATE:String = "onDeactivate";

  /**
   * "Fires when this Window's modal mask is clicked or tapped. Returning <code>false</code> from
   * a handler will veto the subsequent preocessing of the <a href="#!/api/Ext.window.Window-cfg-maskClickAction" rel="Ext.window.Window-cfg-maskClickAction" class="docClass">maskClickAction</a>..
   * @see ext.window.Window
   * @eventType onMaskClick
   */
  public static const MASK_CLICK:String = "onMaskClick";

  /**
   * "Fires after the window has been maximized.
   * @see ext.window.Window
   * @eventType onMaximize
   */
  public static const MAXIMIZE:String = "onMaximize";

  /**
   * "Fires after the window has been minimized.
   * @see ext.window.Window
   * @eventType onMinimize
   */
  public static const MINIMIZE:String = "onMinimize";

  /**
   * "Fires after the window has been restored to its original size after being maximized.
   * @see ext.window.Window
   * @eventType onRestore
   */
  public static const RESTORE:String = "onRestore";

  public function WindowEvent(type:String, arguments:Array) {
    super(null, null);
  }

  public native function get source():ext.window.Window;
}
}