/**
 * Fixes setUI so that ui change will be delegated to the panel title if existing.
 */
Ext.define('JooOverrides.Ext.panel.Header', {
  override: 'Ext.panel.Header',

  /**
   * @inheritdoc
   */
  setUI: function(ui) {
    var me = this,
        title = me.title;

    if (title.rendered) {
      // panel title has set a class representing the container it was added to
      // this class must be removed before the ui change
      me.remove(title, false);
    }

    me.callParent(arguments);

    if (title.rendered) {
      // readd the title to the header
      me.add(title);
      title.setUI(ui);
    }
  }
});
